#define vl_endianfun		/* define message structures */
#include "acl.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "acl.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("acl_c4123e02", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "acl_plugin_get_version_51077d14",
                                VL_API_ACL_PLUGIN_GET_VERSION + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_plugin_get_version_reply_9b32cf86",
                                VL_API_ACL_PLUGIN_GET_VERSION_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_plugin_control_ping_51077d14",
                                VL_API_ACL_PLUGIN_CONTROL_PING + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_plugin_control_ping_reply_f6b0b8ca",
                                VL_API_ACL_PLUGIN_CONTROL_PING_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_plugin_get_conn_table_max_entries_51077d14",
                                VL_API_ACL_PLUGIN_GET_CONN_TABLE_MAX_ENTRIES + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_plugin_get_conn_table_max_entries_reply_7a096d3d",
                                VL_API_ACL_PLUGIN_GET_CONN_TABLE_MAX_ENTRIES_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_add_replace_13bc8539",
                                VL_API_ACL_ADD_REPLACE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_add_replace_reply_ac407b0c",
                                VL_API_ACL_ADD_REPLACE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_del_ef34fea4",
                                VL_API_ACL_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_del_reply_e8d4e804",
                                VL_API_ACL_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_interface_add_del_0b2aedd1",
                                VL_API_ACL_INTERFACE_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_interface_add_del_reply_e8d4e804",
                                VL_API_ACL_INTERFACE_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_interface_set_acl_list_8baece38",
                                VL_API_ACL_INTERFACE_SET_ACL_LIST + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_interface_set_acl_list_reply_e8d4e804",
                                VL_API_ACL_INTERFACE_SET_ACL_LIST_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_dump_ef34fea4",
                                VL_API_ACL_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_details_f89d7a88",
                                VL_API_ACL_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_interface_list_dump_529cb13f",
                                VL_API_ACL_INTERFACE_LIST_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_interface_list_details_d5e80809",
                                VL_API_ACL_INTERFACE_LIST_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_add_0c680ca5",
                                VL_API_MACIP_ACL_ADD + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_add_reply_ac407b0c",
                                VL_API_MACIP_ACL_ADD_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_add_replace_d3d313e7",
                                VL_API_MACIP_ACL_ADD_REPLACE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_add_replace_reply_ac407b0c",
                                VL_API_MACIP_ACL_ADD_REPLACE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_del_ef34fea4",
                                VL_API_MACIP_ACL_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_del_reply_e8d4e804",
                                VL_API_MACIP_ACL_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_interface_add_del_6a6be97c",
                                VL_API_MACIP_ACL_INTERFACE_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_interface_add_del_reply_e8d4e804",
                                VL_API_MACIP_ACL_INTERFACE_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_dump_ef34fea4",
                                VL_API_MACIP_ACL_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_details_e164e69a",
                                VL_API_MACIP_ACL_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_interface_get_51077d14",
                                VL_API_MACIP_ACL_INTERFACE_GET + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_interface_get_reply_accf9b05",
                                VL_API_MACIP_ACL_INTERFACE_GET_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_interface_list_dump_529cb13f",
                                VL_API_MACIP_ACL_INTERFACE_LIST_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "macip_acl_interface_list_details_29783fa0",
                                VL_API_MACIP_ACL_INTERFACE_LIST_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_interface_set_etype_whitelist_f515efc5",
                                VL_API_ACL_INTERFACE_SET_ETYPE_WHITELIST + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_interface_set_etype_whitelist_reply_e8d4e804",
                                VL_API_ACL_INTERFACE_SET_ETYPE_WHITELIST_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_interface_etype_whitelist_dump_529cb13f",
                                VL_API_ACL_INTERFACE_ETYPE_WHITELIST_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_interface_etype_whitelist_details_6a5d4e81",
                                VL_API_ACL_INTERFACE_ETYPE_WHITELIST_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_stats_intf_counters_enable_b3e225d2",
                                VL_API_ACL_STATS_INTF_COUNTERS_ENABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "acl_stats_intf_counters_enable_reply_e8d4e804",
                                VL_API_ACL_STATS_INTF_COUNTERS_ENABLE_REPLY + msg_id_base);
   vl_msg_api_set_handlers(VL_API_ACL_PLUGIN_GET_VERSION + msg_id_base, "acl_plugin_get_version",
                           vl_api_acl_plugin_get_version_t_handler, vl_noop_handler,
                           vl_api_acl_plugin_get_version_t_endian, vl_api_acl_plugin_get_version_t_print,
                           sizeof(vl_api_acl_plugin_get_version_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_PLUGIN_CONTROL_PING + msg_id_base, "acl_plugin_control_ping",
                           vl_api_acl_plugin_control_ping_t_handler, vl_noop_handler,
                           vl_api_acl_plugin_control_ping_t_endian, vl_api_acl_plugin_control_ping_t_print,
                           sizeof(vl_api_acl_plugin_control_ping_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_PLUGIN_GET_CONN_TABLE_MAX_ENTRIES + msg_id_base, "acl_plugin_get_conn_table_max_entries",
                           vl_api_acl_plugin_get_conn_table_max_entries_t_handler, vl_noop_handler,
                           vl_api_acl_plugin_get_conn_table_max_entries_t_endian, vl_api_acl_plugin_get_conn_table_max_entries_t_print,
                           sizeof(vl_api_acl_plugin_get_conn_table_max_entries_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_ADD_REPLACE + msg_id_base, "acl_add_replace",
                           vl_api_acl_add_replace_t_handler, vl_noop_handler,
                           vl_api_acl_add_replace_t_endian, vl_api_acl_add_replace_t_print,
                           sizeof(vl_api_acl_add_replace_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_DEL + msg_id_base, "acl_del",
                           vl_api_acl_del_t_handler, vl_noop_handler,
                           vl_api_acl_del_t_endian, vl_api_acl_del_t_print,
                           sizeof(vl_api_acl_del_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_INTERFACE_ADD_DEL + msg_id_base, "acl_interface_add_del",
                           vl_api_acl_interface_add_del_t_handler, vl_noop_handler,
                           vl_api_acl_interface_add_del_t_endian, vl_api_acl_interface_add_del_t_print,
                           sizeof(vl_api_acl_interface_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_INTERFACE_SET_ACL_LIST + msg_id_base, "acl_interface_set_acl_list",
                           vl_api_acl_interface_set_acl_list_t_handler, vl_noop_handler,
                           vl_api_acl_interface_set_acl_list_t_endian, vl_api_acl_interface_set_acl_list_t_print,
                           sizeof(vl_api_acl_interface_set_acl_list_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_DUMP + msg_id_base, "acl_dump",
                           vl_api_acl_dump_t_handler, vl_noop_handler,
                           vl_api_acl_dump_t_endian, vl_api_acl_dump_t_print,
                           sizeof(vl_api_acl_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_INTERFACE_LIST_DUMP + msg_id_base, "acl_interface_list_dump",
                           vl_api_acl_interface_list_dump_t_handler, vl_noop_handler,
                           vl_api_acl_interface_list_dump_t_endian, vl_api_acl_interface_list_dump_t_print,
                           sizeof(vl_api_acl_interface_list_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_MACIP_ACL_ADD + msg_id_base, "macip_acl_add",
                           vl_api_macip_acl_add_t_handler, vl_noop_handler,
                           vl_api_macip_acl_add_t_endian, vl_api_macip_acl_add_t_print,
                           sizeof(vl_api_macip_acl_add_t), 1);
   vl_msg_api_set_handlers(VL_API_MACIP_ACL_ADD_REPLACE + msg_id_base, "macip_acl_add_replace",
                           vl_api_macip_acl_add_replace_t_handler, vl_noop_handler,
                           vl_api_macip_acl_add_replace_t_endian, vl_api_macip_acl_add_replace_t_print,
                           sizeof(vl_api_macip_acl_add_replace_t), 1);
   vl_msg_api_set_handlers(VL_API_MACIP_ACL_DEL + msg_id_base, "macip_acl_del",
                           vl_api_macip_acl_del_t_handler, vl_noop_handler,
                           vl_api_macip_acl_del_t_endian, vl_api_macip_acl_del_t_print,
                           sizeof(vl_api_macip_acl_del_t), 1);
   vl_msg_api_set_handlers(VL_API_MACIP_ACL_INTERFACE_ADD_DEL + msg_id_base, "macip_acl_interface_add_del",
                           vl_api_macip_acl_interface_add_del_t_handler, vl_noop_handler,
                           vl_api_macip_acl_interface_add_del_t_endian, vl_api_macip_acl_interface_add_del_t_print,
                           sizeof(vl_api_macip_acl_interface_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_MACIP_ACL_DUMP + msg_id_base, "macip_acl_dump",
                           vl_api_macip_acl_dump_t_handler, vl_noop_handler,
                           vl_api_macip_acl_dump_t_endian, vl_api_macip_acl_dump_t_print,
                           sizeof(vl_api_macip_acl_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_MACIP_ACL_INTERFACE_GET + msg_id_base, "macip_acl_interface_get",
                           vl_api_macip_acl_interface_get_t_handler, vl_noop_handler,
                           vl_api_macip_acl_interface_get_t_endian, vl_api_macip_acl_interface_get_t_print,
                           sizeof(vl_api_macip_acl_interface_get_t), 1);
   vl_msg_api_set_handlers(VL_API_MACIP_ACL_INTERFACE_LIST_DUMP + msg_id_base, "macip_acl_interface_list_dump",
                           vl_api_macip_acl_interface_list_dump_t_handler, vl_noop_handler,
                           vl_api_macip_acl_interface_list_dump_t_endian, vl_api_macip_acl_interface_list_dump_t_print,
                           sizeof(vl_api_macip_acl_interface_list_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_INTERFACE_SET_ETYPE_WHITELIST + msg_id_base, "acl_interface_set_etype_whitelist",
                           vl_api_acl_interface_set_etype_whitelist_t_handler, vl_noop_handler,
                           vl_api_acl_interface_set_etype_whitelist_t_endian, vl_api_acl_interface_set_etype_whitelist_t_print,
                           sizeof(vl_api_acl_interface_set_etype_whitelist_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_INTERFACE_ETYPE_WHITELIST_DUMP + msg_id_base, "acl_interface_etype_whitelist_dump",
                           vl_api_acl_interface_etype_whitelist_dump_t_handler, vl_noop_handler,
                           vl_api_acl_interface_etype_whitelist_dump_t_endian, vl_api_acl_interface_etype_whitelist_dump_t_print,
                           sizeof(vl_api_acl_interface_etype_whitelist_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_ACL_STATS_INTF_COUNTERS_ENABLE + msg_id_base, "acl_stats_intf_counters_enable",
                           vl_api_acl_stats_intf_counters_enable_t_handler, vl_noop_handler,
                           vl_api_acl_stats_intf_counters_enable_t_endian, vl_api_acl_stats_intf_counters_enable_t_print,
                           sizeof(vl_api_acl_stats_intf_counters_enable_t), 1);
   return msg_id_base;
}
