#define vl_endianfun		/* define message structures */
#include "dhcp.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "dhcp.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("dhcp_9ad28d0a", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "dhcp_plugin_get_version_51077d14",
                                VL_API_DHCP_PLUGIN_GET_VERSION + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_plugin_get_version_reply_9b32cf86",
                                VL_API_DHCP_PLUGIN_GET_VERSION_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_plugin_control_ping_51077d14",
                                VL_API_DHCP_PLUGIN_CONTROL_PING + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_plugin_control_ping_reply_f6b0b8ca",
                                VL_API_DHCP_PLUGIN_CONTROL_PING_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_proxy_config_6767230e",
                                VL_API_DHCP_PROXY_CONFIG + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_proxy_config_reply_e8d4e804",
                                VL_API_DHCP_PROXY_CONFIG_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_proxy_set_vss_50537301",
                                VL_API_DHCP_PROXY_SET_VSS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_proxy_set_vss_reply_e8d4e804",
                                VL_API_DHCP_PROXY_SET_VSS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_client_config_959b80a3",
                                VL_API_DHCP_CLIENT_CONFIG + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_client_config_reply_e8d4e804",
                                VL_API_DHCP_CLIENT_CONFIG_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_compl_event_e908fd1d",
                                VL_API_DHCP_COMPL_EVENT + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_client_dump_51077d14",
                                VL_API_DHCP_CLIENT_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_client_details_acd82f5a",
                                VL_API_DHCP_CLIENT_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_proxy_dump_5c5b063f",
                                VL_API_DHCP_PROXY_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp_proxy_details_ce16f044",
                                VL_API_DHCP_PROXY_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp6_duid_ll_set_0f6ca323",
                                VL_API_DHCP6_DUID_LL_SET + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp6_duid_ll_set_reply_e8d4e804",
                                VL_API_DHCP6_DUID_LL_SET_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp6_clients_enable_disable_b3e225d2",
                                VL_API_DHCP6_CLIENTS_ENABLE_DISABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp6_clients_enable_disable_reply_e8d4e804",
                                VL_API_DHCP6_CLIENTS_ENABLE_DISABLE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp6_send_client_message_f6f14ef0",
                                VL_API_DHCP6_SEND_CLIENT_MESSAGE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp6_send_client_message_reply_e8d4e804",
                                VL_API_DHCP6_SEND_CLIENT_MESSAGE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp6_pd_send_client_message_064badb8",
                                VL_API_DHCP6_PD_SEND_CLIENT_MESSAGE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp6_pd_send_client_message_reply_e8d4e804",
                                VL_API_DHCP6_PD_SEND_CLIENT_MESSAGE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "want_dhcp6_reply_events_05b454b5",
                                VL_API_WANT_DHCP6_REPLY_EVENTS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "want_dhcp6_reply_events_reply_e8d4e804",
                                VL_API_WANT_DHCP6_REPLY_EVENTS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "want_dhcp6_pd_reply_events_c5e2af94",
                                VL_API_WANT_DHCP6_PD_REPLY_EVENTS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "want_dhcp6_pd_reply_events_reply_e8d4e804",
                                VL_API_WANT_DHCP6_PD_REPLY_EVENTS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp6_reply_event_9f3af9e5",
                                VL_API_DHCP6_REPLY_EVENT + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dhcp6_pd_reply_event_cb3e462b",
                                VL_API_DHCP6_PD_REPLY_EVENT + msg_id_base);
   vl_msg_api_set_handlers(VL_API_DHCP_CLIENT_CONFIG + msg_id_base, "dhcp_client_config",
                           vl_api_dhcp_client_config_t_handler, vl_noop_handler,
                           vl_api_dhcp_client_config_t_endian, vl_api_dhcp_client_config_t_print,
                           sizeof(vl_api_dhcp_client_config_t), 1);
   vl_msg_api_set_handlers(VL_API_WANT_DHCP6_REPLY_EVENTS + msg_id_base, "want_dhcp6_reply_events",
                           vl_api_want_dhcp6_reply_events_t_handler, vl_noop_handler,
                           vl_api_want_dhcp6_reply_events_t_endian, vl_api_want_dhcp6_reply_events_t_print,
                           sizeof(vl_api_want_dhcp6_reply_events_t), 1);
   vl_msg_api_set_handlers(VL_API_WANT_DHCP6_PD_REPLY_EVENTS + msg_id_base, "want_dhcp6_pd_reply_events",
                           vl_api_want_dhcp6_pd_reply_events_t_handler, vl_noop_handler,
                           vl_api_want_dhcp6_pd_reply_events_t_endian, vl_api_want_dhcp6_pd_reply_events_t_print,
                           sizeof(vl_api_want_dhcp6_pd_reply_events_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP_PLUGIN_GET_VERSION + msg_id_base, "dhcp_plugin_get_version",
                           vl_api_dhcp_plugin_get_version_t_handler, vl_noop_handler,
                           vl_api_dhcp_plugin_get_version_t_endian, vl_api_dhcp_plugin_get_version_t_print,
                           sizeof(vl_api_dhcp_plugin_get_version_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP_PLUGIN_CONTROL_PING + msg_id_base, "dhcp_plugin_control_ping",
                           vl_api_dhcp_plugin_control_ping_t_handler, vl_noop_handler,
                           vl_api_dhcp_plugin_control_ping_t_endian, vl_api_dhcp_plugin_control_ping_t_print,
                           sizeof(vl_api_dhcp_plugin_control_ping_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP_PROXY_CONFIG + msg_id_base, "dhcp_proxy_config",
                           vl_api_dhcp_proxy_config_t_handler, vl_noop_handler,
                           vl_api_dhcp_proxy_config_t_endian, vl_api_dhcp_proxy_config_t_print,
                           sizeof(vl_api_dhcp_proxy_config_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP_PROXY_SET_VSS + msg_id_base, "dhcp_proxy_set_vss",
                           vl_api_dhcp_proxy_set_vss_t_handler, vl_noop_handler,
                           vl_api_dhcp_proxy_set_vss_t_endian, vl_api_dhcp_proxy_set_vss_t_print,
                           sizeof(vl_api_dhcp_proxy_set_vss_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP_CLIENT_DUMP + msg_id_base, "dhcp_client_dump",
                           vl_api_dhcp_client_dump_t_handler, vl_noop_handler,
                           vl_api_dhcp_client_dump_t_endian, vl_api_dhcp_client_dump_t_print,
                           sizeof(vl_api_dhcp_client_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP_PROXY_DUMP + msg_id_base, "dhcp_proxy_dump",
                           vl_api_dhcp_proxy_dump_t_handler, vl_noop_handler,
                           vl_api_dhcp_proxy_dump_t_endian, vl_api_dhcp_proxy_dump_t_print,
                           sizeof(vl_api_dhcp_proxy_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP6_DUID_LL_SET + msg_id_base, "dhcp6_duid_ll_set",
                           vl_api_dhcp6_duid_ll_set_t_handler, vl_noop_handler,
                           vl_api_dhcp6_duid_ll_set_t_endian, vl_api_dhcp6_duid_ll_set_t_print,
                           sizeof(vl_api_dhcp6_duid_ll_set_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP6_CLIENTS_ENABLE_DISABLE + msg_id_base, "dhcp6_clients_enable_disable",
                           vl_api_dhcp6_clients_enable_disable_t_handler, vl_noop_handler,
                           vl_api_dhcp6_clients_enable_disable_t_endian, vl_api_dhcp6_clients_enable_disable_t_print,
                           sizeof(vl_api_dhcp6_clients_enable_disable_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP6_SEND_CLIENT_MESSAGE + msg_id_base, "dhcp6_send_client_message",
                           vl_api_dhcp6_send_client_message_t_handler, vl_noop_handler,
                           vl_api_dhcp6_send_client_message_t_endian, vl_api_dhcp6_send_client_message_t_print,
                           sizeof(vl_api_dhcp6_send_client_message_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP6_PD_SEND_CLIENT_MESSAGE + msg_id_base, "dhcp6_pd_send_client_message",
                           vl_api_dhcp6_pd_send_client_message_t_handler, vl_noop_handler,
                           vl_api_dhcp6_pd_send_client_message_t_endian, vl_api_dhcp6_pd_send_client_message_t_print,
                           sizeof(vl_api_dhcp6_pd_send_client_message_t), 1);
   return msg_id_base;
}
