#define vl_endianfun		/* define message structures */
#include "dhcp.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "dhcp.api.h"
#undef vl_printfun

#ifndef VL_API_DHCP_CLIENT_CONFIG_REPLY_T_HANDLER
static void
vl_api_dhcp_client_config_reply_t_handler (vl_api_dhcp_client_config_reply_t * mp) {
   vat_main_t * vam = dhcp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
static void
vl_api_dhcp_compl_event_t_handler (vl_api_dhcp_compl_event_t * mp) {
    vl_print(0, "dhcp_compl_event event called:");
    vl_api_dhcp_compl_event_t_print(mp, 0);
}
#ifndef VL_API_WANT_DHCP6_REPLY_EVENTS_REPLY_T_HANDLER
static void
vl_api_want_dhcp6_reply_events_reply_t_handler (vl_api_want_dhcp6_reply_events_reply_t * mp) {
   vat_main_t * vam = dhcp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
static void
vl_api_dhcp6_reply_event_t_handler (vl_api_dhcp6_reply_event_t * mp) {
    vl_print(0, "dhcp6_reply_event event called:");
    vl_api_dhcp6_reply_event_t_print(mp, 0);
}
#ifndef VL_API_WANT_DHCP6_PD_REPLY_EVENTS_REPLY_T_HANDLER
static void
vl_api_want_dhcp6_pd_reply_events_reply_t_handler (vl_api_want_dhcp6_pd_reply_events_reply_t * mp) {
   vat_main_t * vam = dhcp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
static void
vl_api_dhcp6_pd_reply_event_t_handler (vl_api_dhcp6_pd_reply_event_t * mp) {
    vl_print(0, "dhcp6_pd_reply_event event called:");
    vl_api_dhcp6_pd_reply_event_t_print(mp, 0);
}
/* Only autoreply is supported (vl_api_dhcp_plugin_get_version_reply_t_handler()) */
/* Only autoreply is supported (vl_api_dhcp_plugin_control_ping_reply_t_handler()) */
#ifndef VL_API_DHCP_PROXY_CONFIG_REPLY_T_HANDLER
static void
vl_api_dhcp_proxy_config_reply_t_handler (vl_api_dhcp_proxy_config_reply_t * mp) {
   vat_main_t * vam = dhcp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
#ifndef VL_API_DHCP_PROXY_SET_VSS_REPLY_T_HANDLER
static void
vl_api_dhcp_proxy_set_vss_reply_t_handler (vl_api_dhcp_proxy_set_vss_reply_t * mp) {
   vat_main_t * vam = dhcp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
/* Only autoreply is supported (vl_api_dhcp_client_details_t_handler()) */
/* Manual definition requested for: vl_api_dhcp_proxy_details_t_handler() */
#ifndef VL_API_DHCP6_DUID_LL_SET_REPLY_T_HANDLER
static void
vl_api_dhcp6_duid_ll_set_reply_t_handler (vl_api_dhcp6_duid_ll_set_reply_t * mp) {
   vat_main_t * vam = dhcp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
#ifndef VL_API_DHCP6_CLIENTS_ENABLE_DISABLE_REPLY_T_HANDLER
static void
vl_api_dhcp6_clients_enable_disable_reply_t_handler (vl_api_dhcp6_clients_enable_disable_reply_t * mp) {
   vat_main_t * vam = dhcp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
#ifndef VL_API_DHCP6_SEND_CLIENT_MESSAGE_REPLY_T_HANDLER
static void
vl_api_dhcp6_send_client_message_reply_t_handler (vl_api_dhcp6_send_client_message_reply_t * mp) {
   vat_main_t * vam = dhcp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
#ifndef VL_API_DHCP6_PD_SEND_CLIENT_MESSAGE_REPLY_T_HANDLER
static void
vl_api_dhcp6_pd_send_client_message_reply_t_handler (vl_api_dhcp6_pd_send_client_message_reply_t * mp) {
   vat_main_t * vam = dhcp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
static void
setup_message_id_table (vat_main_t * vam, u16 msg_id_base) {
   vl_msg_api_set_handlers(VL_API_DHCP_CLIENT_CONFIG_REPLY + msg_id_base, "dhcp_client_config_reply",
                           vl_api_dhcp_client_config_reply_t_handler, vl_noop_handler,
                           vl_api_dhcp_client_config_reply_t_endian, vl_api_dhcp_client_config_reply_t_print,
                           sizeof(vl_api_dhcp_client_config_reply_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp_client_config", api_dhcp_client_config);
   vl_msg_api_set_handlers(VL_API_DHCP_COMPL_EVENT + msg_id_base, "dhcp_compl_event",
                           vl_api_dhcp_compl_event_t_handler, vl_noop_handler,
                           vl_api_dhcp_compl_event_t_endian, vl_api_dhcp_compl_event_t_print,
                           sizeof(vl_api_dhcp_compl_event_t), 1);
   vl_msg_api_set_handlers(VL_API_WANT_DHCP6_REPLY_EVENTS_REPLY + msg_id_base, "want_dhcp6_reply_events_reply",
                           vl_api_want_dhcp6_reply_events_reply_t_handler, vl_noop_handler,
                           vl_api_want_dhcp6_reply_events_reply_t_endian, vl_api_want_dhcp6_reply_events_reply_t_print,
                           sizeof(vl_api_want_dhcp6_reply_events_reply_t), 1);
   hash_set_mem (vam->function_by_name, "want_dhcp6_reply_events", api_want_dhcp6_reply_events);
   vl_msg_api_set_handlers(VL_API_DHCP6_REPLY_EVENT + msg_id_base, "dhcp6_reply_event",
                           vl_api_dhcp6_reply_event_t_handler, vl_noop_handler,
                           vl_api_dhcp6_reply_event_t_endian, vl_api_dhcp6_reply_event_t_print,
                           sizeof(vl_api_dhcp6_reply_event_t), 1);
   vl_msg_api_set_handlers(VL_API_WANT_DHCP6_PD_REPLY_EVENTS_REPLY + msg_id_base, "want_dhcp6_pd_reply_events_reply",
                           vl_api_want_dhcp6_pd_reply_events_reply_t_handler, vl_noop_handler,
                           vl_api_want_dhcp6_pd_reply_events_reply_t_endian, vl_api_want_dhcp6_pd_reply_events_reply_t_print,
                           sizeof(vl_api_want_dhcp6_pd_reply_events_reply_t), 1);
   hash_set_mem (vam->function_by_name, "want_dhcp6_pd_reply_events", api_want_dhcp6_pd_reply_events);
   vl_msg_api_set_handlers(VL_API_DHCP6_PD_REPLY_EVENT + msg_id_base, "dhcp6_pd_reply_event",
                           vl_api_dhcp6_pd_reply_event_t_handler, vl_noop_handler,
                           vl_api_dhcp6_pd_reply_event_t_endian, vl_api_dhcp6_pd_reply_event_t_print,
                           sizeof(vl_api_dhcp6_pd_reply_event_t), 1);
   vl_msg_api_set_handlers(VL_API_DHCP_PLUGIN_GET_VERSION_REPLY + msg_id_base, "dhcp_plugin_get_version_reply",
                           vl_api_dhcp_plugin_get_version_reply_t_handler, vl_noop_handler,
                           vl_api_dhcp_plugin_get_version_reply_t_endian, vl_api_dhcp_plugin_get_version_reply_t_print,
                           sizeof(vl_api_dhcp_plugin_get_version_reply_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp_plugin_get_version", api_dhcp_plugin_get_version);
   vl_msg_api_set_handlers(VL_API_DHCP_PLUGIN_CONTROL_PING_REPLY + msg_id_base, "dhcp_plugin_control_ping_reply",
                           vl_api_dhcp_plugin_control_ping_reply_t_handler, vl_noop_handler,
                           vl_api_dhcp_plugin_control_ping_reply_t_endian, vl_api_dhcp_plugin_control_ping_reply_t_print,
                           sizeof(vl_api_dhcp_plugin_control_ping_reply_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp_plugin_control_ping", api_dhcp_plugin_control_ping);
   vl_msg_api_set_handlers(VL_API_DHCP_PROXY_CONFIG_REPLY + msg_id_base, "dhcp_proxy_config_reply",
                           vl_api_dhcp_proxy_config_reply_t_handler, vl_noop_handler,
                           vl_api_dhcp_proxy_config_reply_t_endian, vl_api_dhcp_proxy_config_reply_t_print,
                           sizeof(vl_api_dhcp_proxy_config_reply_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp_proxy_config", api_dhcp_proxy_config);
   vl_msg_api_set_handlers(VL_API_DHCP_PROXY_SET_VSS_REPLY + msg_id_base, "dhcp_proxy_set_vss_reply",
                           vl_api_dhcp_proxy_set_vss_reply_t_handler, vl_noop_handler,
                           vl_api_dhcp_proxy_set_vss_reply_t_endian, vl_api_dhcp_proxy_set_vss_reply_t_print,
                           sizeof(vl_api_dhcp_proxy_set_vss_reply_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp_proxy_set_vss", api_dhcp_proxy_set_vss);
   vl_msg_api_set_handlers(VL_API_DHCP_CLIENT_DETAILS + msg_id_base, "dhcp_client_details",
                           vl_api_dhcp_client_details_t_handler, vl_noop_handler,
                           vl_api_dhcp_client_details_t_endian, vl_api_dhcp_client_details_t_print,
                           sizeof(vl_api_dhcp_client_details_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp_client_dump", api_dhcp_client_dump);
   vl_msg_api_set_handlers(VL_API_DHCP_PROXY_DETAILS + msg_id_base, "dhcp_proxy_details",
                           vl_api_dhcp_proxy_details_t_handler, vl_noop_handler,
                           vl_api_dhcp_proxy_details_t_endian, vl_api_dhcp_proxy_details_t_print,
                           sizeof(vl_api_dhcp_proxy_details_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp_proxy_dump", api_dhcp_proxy_dump);
   vl_msg_api_set_handlers(VL_API_DHCP6_DUID_LL_SET_REPLY + msg_id_base, "dhcp6_duid_ll_set_reply",
                           vl_api_dhcp6_duid_ll_set_reply_t_handler, vl_noop_handler,
                           vl_api_dhcp6_duid_ll_set_reply_t_endian, vl_api_dhcp6_duid_ll_set_reply_t_print,
                           sizeof(vl_api_dhcp6_duid_ll_set_reply_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp6_duid_ll_set", api_dhcp6_duid_ll_set);
   vl_msg_api_set_handlers(VL_API_DHCP6_CLIENTS_ENABLE_DISABLE_REPLY + msg_id_base, "dhcp6_clients_enable_disable_reply",
                           vl_api_dhcp6_clients_enable_disable_reply_t_handler, vl_noop_handler,
                           vl_api_dhcp6_clients_enable_disable_reply_t_endian, vl_api_dhcp6_clients_enable_disable_reply_t_print,
                           sizeof(vl_api_dhcp6_clients_enable_disable_reply_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp6_clients_enable_disable", api_dhcp6_clients_enable_disable);
   vl_msg_api_set_handlers(VL_API_DHCP6_SEND_CLIENT_MESSAGE_REPLY + msg_id_base, "dhcp6_send_client_message_reply",
                           vl_api_dhcp6_send_client_message_reply_t_handler, vl_noop_handler,
                           vl_api_dhcp6_send_client_message_reply_t_endian, vl_api_dhcp6_send_client_message_reply_t_print,
                           sizeof(vl_api_dhcp6_send_client_message_reply_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp6_send_client_message", api_dhcp6_send_client_message);
   vl_msg_api_set_handlers(VL_API_DHCP6_PD_SEND_CLIENT_MESSAGE_REPLY + msg_id_base, "dhcp6_pd_send_client_message_reply",
                           vl_api_dhcp6_pd_send_client_message_reply_t_handler, vl_noop_handler,
                           vl_api_dhcp6_pd_send_client_message_reply_t_endian, vl_api_dhcp6_pd_send_client_message_reply_t_print,
                           sizeof(vl_api_dhcp6_pd_send_client_message_reply_t), 1);
   hash_set_mem (vam->function_by_name, "dhcp6_pd_send_client_message", api_dhcp6_pd_send_client_message);
}
clib_error_t * vat_plugin_register (vat_main_t *vam)
{
   dhcp_test_main_t * mainp = &dhcp_test_main;
   mainp->vat_main = vam;
   mainp->msg_id_base = vl_client_get_first_plugin_msg_id ("dhcp_9ad28d0a");
   if (mainp->msg_id_base == (u16) ~0)
      return clib_error_return (0, "dhcp plugin not loaded...");
   setup_message_id_table (vam, mainp->msg_id_base);
#ifdef VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE
    VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE(vam);
#endif
   return 0;
}
