#define vl_endianfun		/* define message structures */
#include "dns.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "dns.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("dns_269575cd", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "dns_enable_disable_8050327d",
                                VL_API_DNS_ENABLE_DISABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dns_enable_disable_reply_e8d4e804",
                                VL_API_DNS_ENABLE_DISABLE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dns_name_server_add_del_3bb05d8c",
                                VL_API_DNS_NAME_SERVER_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dns_name_server_add_del_reply_e8d4e804",
                                VL_API_DNS_NAME_SERVER_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dns_resolve_name_c6566676",
                                VL_API_DNS_RESOLVE_NAME + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dns_resolve_name_reply_c2d758c3",
                                VL_API_DNS_RESOLVE_NAME_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dns_resolve_ip_ae96a1a3",
                                VL_API_DNS_RESOLVE_IP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "dns_resolve_ip_reply_49ed78d6",
                                VL_API_DNS_RESOLVE_IP_REPLY + msg_id_base);
   vl_msg_api_set_handlers(VL_API_DNS_ENABLE_DISABLE + msg_id_base, "dns_enable_disable",
                           vl_api_dns_enable_disable_t_handler, vl_noop_handler,
                           vl_api_dns_enable_disable_t_endian, vl_api_dns_enable_disable_t_print,
                           sizeof(vl_api_dns_enable_disable_t), 1);
   vl_msg_api_set_handlers(VL_API_DNS_NAME_SERVER_ADD_DEL + msg_id_base, "dns_name_server_add_del",
                           vl_api_dns_name_server_add_del_t_handler, vl_noop_handler,
                           vl_api_dns_name_server_add_del_t_endian, vl_api_dns_name_server_add_del_t_print,
                           sizeof(vl_api_dns_name_server_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_DNS_RESOLVE_NAME + msg_id_base, "dns_resolve_name",
                           vl_api_dns_resolve_name_t_handler, vl_noop_handler,
                           vl_api_dns_resolve_name_t_endian, vl_api_dns_resolve_name_t_print,
                           sizeof(vl_api_dns_resolve_name_t), 1);
   vl_msg_api_set_handlers(VL_API_DNS_RESOLVE_IP + msg_id_base, "dns_resolve_ip",
                           vl_api_dns_resolve_ip_t_handler, vl_noop_handler,
                           vl_api_dns_resolve_ip_t_endian, vl_api_dns_resolve_ip_t_print,
                           sizeof(vl_api_dns_resolve_ip_t), 1);
   return msg_id_base;
}
