#define vl_endianfun		/* define message structures */
#include "flowprobe.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "flowprobe.api.h"
#undef vl_printfun

#ifndef VL_API_FLOWPROBE_TX_INTERFACE_ADD_DEL_REPLY_T_HANDLER
static void
vl_api_flowprobe_tx_interface_add_del_reply_t_handler (vl_api_flowprobe_tx_interface_add_del_reply_t * mp) {
   vat_main_t * vam = flowprobe_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
#ifndef VL_API_FLOWPROBE_PARAMS_REPLY_T_HANDLER
static void
vl_api_flowprobe_params_reply_t_handler (vl_api_flowprobe_params_reply_t * mp) {
   vat_main_t * vam = flowprobe_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
static void
setup_message_id_table (vat_main_t * vam, u16 msg_id_base) {
   vl_msg_api_set_handlers(VL_API_FLOWPROBE_TX_INTERFACE_ADD_DEL_REPLY + msg_id_base, "flowprobe_tx_interface_add_del_reply",
                           vl_api_flowprobe_tx_interface_add_del_reply_t_handler, vl_noop_handler,
                           vl_api_flowprobe_tx_interface_add_del_reply_t_endian, vl_api_flowprobe_tx_interface_add_del_reply_t_print,
                           sizeof(vl_api_flowprobe_tx_interface_add_del_reply_t), 1);
   hash_set_mem (vam->function_by_name, "flowprobe_tx_interface_add_del", api_flowprobe_tx_interface_add_del);
   hash_set_mem (vam->help_by_name, "flowprobe_tx_interface_add_del", "<intfc> [disable]");
   vl_msg_api_set_handlers(VL_API_FLOWPROBE_PARAMS_REPLY + msg_id_base, "flowprobe_params_reply",
                           vl_api_flowprobe_params_reply_t_handler, vl_noop_handler,
                           vl_api_flowprobe_params_reply_t_endian, vl_api_flowprobe_params_reply_t_print,
                           sizeof(vl_api_flowprobe_params_reply_t), 1);
   hash_set_mem (vam->function_by_name, "flowprobe_params", api_flowprobe_params);
   hash_set_mem (vam->help_by_name, "flowprobe_params", "record <[l2] [l3] [l4]> [active <timer> passive <timer>]");
}
clib_error_t * vat_plugin_register (vat_main_t *vam)
{
   flowprobe_test_main_t * mainp = &flowprobe_test_main;
   mainp->vat_main = vam;
   mainp->msg_id_base = vl_client_get_first_plugin_msg_id ("flowprobe_5f3ac69e");
   if (mainp->msg_id_base == (u16) ~0)
      return clib_error_return (0, "flowprobe plugin not loaded...");
   setup_message_id_table (vam, mainp->msg_id_base);
#ifdef VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE
    VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE(vam);
#endif
   return 0;
}
