#define vl_endianfun		/* define message structures */
#include "gbp.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "gbp.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("gbp_9aca7f65", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "gbp_bridge_domain_add_8454bfdf",
                                VL_API_GBP_BRIDGE_DOMAIN_ADD + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_bridge_domain_add_reply_e8d4e804",
                                VL_API_GBP_BRIDGE_DOMAIN_ADD_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_bridge_domain_del_c25fdce6",
                                VL_API_GBP_BRIDGE_DOMAIN_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_bridge_domain_del_reply_e8d4e804",
                                VL_API_GBP_BRIDGE_DOMAIN_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_bridge_domain_dump_51077d14",
                                VL_API_GBP_BRIDGE_DOMAIN_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_bridge_domain_dump_reply_e8d4e804",
                                VL_API_GBP_BRIDGE_DOMAIN_DUMP_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_bridge_domain_details_2acd15f9",
                                VL_API_GBP_BRIDGE_DOMAIN_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_route_domain_add_2d0afe38",
                                VL_API_GBP_ROUTE_DOMAIN_ADD + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_route_domain_add_reply_e8d4e804",
                                VL_API_GBP_ROUTE_DOMAIN_ADD_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_route_domain_del_bee4edcd",
                                VL_API_GBP_ROUTE_DOMAIN_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_route_domain_del_reply_e8d4e804",
                                VL_API_GBP_ROUTE_DOMAIN_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_route_domain_dump_51077d14",
                                VL_API_GBP_ROUTE_DOMAIN_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_route_domain_dump_reply_e8d4e804",
                                VL_API_GBP_ROUTE_DOMAIN_DUMP_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_route_domain_details_8ab11375",
                                VL_API_GBP_ROUTE_DOMAIN_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_add_9ce16d5a",
                                VL_API_GBP_ENDPOINT_ADD + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_add_reply_1dd3ff3e",
                                VL_API_GBP_ENDPOINT_ADD_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_del_b93cd566",
                                VL_API_GBP_ENDPOINT_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_del_reply_e8d4e804",
                                VL_API_GBP_ENDPOINT_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_dump_51077d14",
                                VL_API_GBP_ENDPOINT_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_details_08aecb60",
                                VL_API_GBP_ENDPOINT_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_group_add_8e0f4054",
                                VL_API_GBP_ENDPOINT_GROUP_ADD + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_group_add_reply_e8d4e804",
                                VL_API_GBP_ENDPOINT_GROUP_ADD_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_group_del_3436b8b7",
                                VL_API_GBP_ENDPOINT_GROUP_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_group_del_reply_e8d4e804",
                                VL_API_GBP_ENDPOINT_GROUP_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_group_dump_51077d14",
                                VL_API_GBP_ENDPOINT_GROUP_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_endpoint_group_details_8f38292c",
                                VL_API_GBP_ENDPOINT_GROUP_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_recirc_add_del_718c69c3",
                                VL_API_GBP_RECIRC_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_recirc_add_del_reply_e8d4e804",
                                VL_API_GBP_RECIRC_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_recirc_dump_51077d14",
                                VL_API_GBP_RECIRC_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_recirc_details_66ecc42e",
                                VL_API_GBP_RECIRC_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_subnet_add_del_888aca35",
                                VL_API_GBP_SUBNET_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_subnet_add_del_reply_e8d4e804",
                                VL_API_GBP_SUBNET_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_subnet_dump_51077d14",
                                VL_API_GBP_SUBNET_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_subnet_details_4ed84156",
                                VL_API_GBP_SUBNET_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_contract_add_del_553e275b",
                                VL_API_GBP_CONTRACT_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_contract_add_del_reply_1992deab",
                                VL_API_GBP_CONTRACT_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_contract_dump_51077d14",
                                VL_API_GBP_CONTRACT_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_contract_details_2a18db6e",
                                VL_API_GBP_CONTRACT_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_vxlan_tunnel_add_3e070b35",
                                VL_API_GBP_VXLAN_TUNNEL_ADD + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_vxlan_tunnel_add_reply_5383d31f",
                                VL_API_GBP_VXLAN_TUNNEL_ADD_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_vxlan_tunnel_del_8d1f2fe9",
                                VL_API_GBP_VXLAN_TUNNEL_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_vxlan_tunnel_del_reply_e8d4e804",
                                VL_API_GBP_VXLAN_TUNNEL_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_vxlan_tunnel_dump_51077d14",
                                VL_API_GBP_VXLAN_TUNNEL_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_vxlan_tunnel_details_65c6c818",
                                VL_API_GBP_VXLAN_TUNNEL_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_ext_itf_add_del_12ed5700",
                                VL_API_GBP_EXT_ITF_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_ext_itf_add_del_reply_e8d4e804",
                                VL_API_GBP_EXT_ITF_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_ext_itf_dump_51077d14",
                                VL_API_GBP_EXT_ITF_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gbp_ext_itf_details_408a45c0",
                                VL_API_GBP_EXT_ITF_DETAILS + msg_id_base);
   vl_msg_api_set_handlers(VL_API_GBP_BRIDGE_DOMAIN_ADD + msg_id_base, "gbp_bridge_domain_add",
                           vl_api_gbp_bridge_domain_add_t_handler, vl_noop_handler,
                           vl_api_gbp_bridge_domain_add_t_endian, vl_api_gbp_bridge_domain_add_t_print,
                           sizeof(vl_api_gbp_bridge_domain_add_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_BRIDGE_DOMAIN_DEL + msg_id_base, "gbp_bridge_domain_del",
                           vl_api_gbp_bridge_domain_del_t_handler, vl_noop_handler,
                           vl_api_gbp_bridge_domain_del_t_endian, vl_api_gbp_bridge_domain_del_t_print,
                           sizeof(vl_api_gbp_bridge_domain_del_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_BRIDGE_DOMAIN_DUMP + msg_id_base, "gbp_bridge_domain_dump",
                           vl_api_gbp_bridge_domain_dump_t_handler, vl_noop_handler,
                           vl_api_gbp_bridge_domain_dump_t_endian, vl_api_gbp_bridge_domain_dump_t_print,
                           sizeof(vl_api_gbp_bridge_domain_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_ROUTE_DOMAIN_ADD + msg_id_base, "gbp_route_domain_add",
                           vl_api_gbp_route_domain_add_t_handler, vl_noop_handler,
                           vl_api_gbp_route_domain_add_t_endian, vl_api_gbp_route_domain_add_t_print,
                           sizeof(vl_api_gbp_route_domain_add_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_ROUTE_DOMAIN_DEL + msg_id_base, "gbp_route_domain_del",
                           vl_api_gbp_route_domain_del_t_handler, vl_noop_handler,
                           vl_api_gbp_route_domain_del_t_endian, vl_api_gbp_route_domain_del_t_print,
                           sizeof(vl_api_gbp_route_domain_del_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_ROUTE_DOMAIN_DUMP + msg_id_base, "gbp_route_domain_dump",
                           vl_api_gbp_route_domain_dump_t_handler, vl_noop_handler,
                           vl_api_gbp_route_domain_dump_t_endian, vl_api_gbp_route_domain_dump_t_print,
                           sizeof(vl_api_gbp_route_domain_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_ENDPOINT_ADD + msg_id_base, "gbp_endpoint_add",
                           vl_api_gbp_endpoint_add_t_handler, vl_noop_handler,
                           vl_api_gbp_endpoint_add_t_endian, vl_api_gbp_endpoint_add_t_print,
                           sizeof(vl_api_gbp_endpoint_add_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_ENDPOINT_DEL + msg_id_base, "gbp_endpoint_del",
                           vl_api_gbp_endpoint_del_t_handler, vl_noop_handler,
                           vl_api_gbp_endpoint_del_t_endian, vl_api_gbp_endpoint_del_t_print,
                           sizeof(vl_api_gbp_endpoint_del_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_ENDPOINT_DUMP + msg_id_base, "gbp_endpoint_dump",
                           vl_api_gbp_endpoint_dump_t_handler, vl_noop_handler,
                           vl_api_gbp_endpoint_dump_t_endian, vl_api_gbp_endpoint_dump_t_print,
                           sizeof(vl_api_gbp_endpoint_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_ENDPOINT_GROUP_ADD + msg_id_base, "gbp_endpoint_group_add",
                           vl_api_gbp_endpoint_group_add_t_handler, vl_noop_handler,
                           vl_api_gbp_endpoint_group_add_t_endian, vl_api_gbp_endpoint_group_add_t_print,
                           sizeof(vl_api_gbp_endpoint_group_add_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_ENDPOINT_GROUP_DEL + msg_id_base, "gbp_endpoint_group_del",
                           vl_api_gbp_endpoint_group_del_t_handler, vl_noop_handler,
                           vl_api_gbp_endpoint_group_del_t_endian, vl_api_gbp_endpoint_group_del_t_print,
                           sizeof(vl_api_gbp_endpoint_group_del_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_ENDPOINT_GROUP_DUMP + msg_id_base, "gbp_endpoint_group_dump",
                           vl_api_gbp_endpoint_group_dump_t_handler, vl_noop_handler,
                           vl_api_gbp_endpoint_group_dump_t_endian, vl_api_gbp_endpoint_group_dump_t_print,
                           sizeof(vl_api_gbp_endpoint_group_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_RECIRC_ADD_DEL + msg_id_base, "gbp_recirc_add_del",
                           vl_api_gbp_recirc_add_del_t_handler, vl_noop_handler,
                           vl_api_gbp_recirc_add_del_t_endian, vl_api_gbp_recirc_add_del_t_print,
                           sizeof(vl_api_gbp_recirc_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_RECIRC_DUMP + msg_id_base, "gbp_recirc_dump",
                           vl_api_gbp_recirc_dump_t_handler, vl_noop_handler,
                           vl_api_gbp_recirc_dump_t_endian, vl_api_gbp_recirc_dump_t_print,
                           sizeof(vl_api_gbp_recirc_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_SUBNET_ADD_DEL + msg_id_base, "gbp_subnet_add_del",
                           vl_api_gbp_subnet_add_del_t_handler, vl_noop_handler,
                           vl_api_gbp_subnet_add_del_t_endian, vl_api_gbp_subnet_add_del_t_print,
                           sizeof(vl_api_gbp_subnet_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_SUBNET_DUMP + msg_id_base, "gbp_subnet_dump",
                           vl_api_gbp_subnet_dump_t_handler, vl_noop_handler,
                           vl_api_gbp_subnet_dump_t_endian, vl_api_gbp_subnet_dump_t_print,
                           sizeof(vl_api_gbp_subnet_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_CONTRACT_ADD_DEL + msg_id_base, "gbp_contract_add_del",
                           vl_api_gbp_contract_add_del_t_handler, vl_noop_handler,
                           vl_api_gbp_contract_add_del_t_endian, vl_api_gbp_contract_add_del_t_print,
                           sizeof(vl_api_gbp_contract_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_CONTRACT_DUMP + msg_id_base, "gbp_contract_dump",
                           vl_api_gbp_contract_dump_t_handler, vl_noop_handler,
                           vl_api_gbp_contract_dump_t_endian, vl_api_gbp_contract_dump_t_print,
                           sizeof(vl_api_gbp_contract_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_VXLAN_TUNNEL_ADD + msg_id_base, "gbp_vxlan_tunnel_add",
                           vl_api_gbp_vxlan_tunnel_add_t_handler, vl_noop_handler,
                           vl_api_gbp_vxlan_tunnel_add_t_endian, vl_api_gbp_vxlan_tunnel_add_t_print,
                           sizeof(vl_api_gbp_vxlan_tunnel_add_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_VXLAN_TUNNEL_DEL + msg_id_base, "gbp_vxlan_tunnel_del",
                           vl_api_gbp_vxlan_tunnel_del_t_handler, vl_noop_handler,
                           vl_api_gbp_vxlan_tunnel_del_t_endian, vl_api_gbp_vxlan_tunnel_del_t_print,
                           sizeof(vl_api_gbp_vxlan_tunnel_del_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_VXLAN_TUNNEL_DUMP + msg_id_base, "gbp_vxlan_tunnel_dump",
                           vl_api_gbp_vxlan_tunnel_dump_t_handler, vl_noop_handler,
                           vl_api_gbp_vxlan_tunnel_dump_t_endian, vl_api_gbp_vxlan_tunnel_dump_t_print,
                           sizeof(vl_api_gbp_vxlan_tunnel_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_EXT_ITF_ADD_DEL + msg_id_base, "gbp_ext_itf_add_del",
                           vl_api_gbp_ext_itf_add_del_t_handler, vl_noop_handler,
                           vl_api_gbp_ext_itf_add_del_t_endian, vl_api_gbp_ext_itf_add_del_t_print,
                           sizeof(vl_api_gbp_ext_itf_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_GBP_EXT_ITF_DUMP + msg_id_base, "gbp_ext_itf_dump",
                           vl_api_gbp_ext_itf_dump_t_handler, vl_noop_handler,
                           vl_api_gbp_ext_itf_dump_t_endian, vl_api_gbp_ext_itf_dump_t_print,
                           sizeof(vl_api_gbp_ext_itf_dump_t), 1);
   return msg_id_base;
}
