#define vl_endianfun		/* define message structures */
#include "gtpu.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "gtpu.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("gtpu_5342c99b", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "gtpu_add_del_tunnel_9a26a51c",
                                VL_API_GTPU_ADD_DEL_TUNNEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gtpu_add_del_tunnel_reply_5383d31f",
                                VL_API_GTPU_ADD_DEL_TUNNEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gtpu_tunnel_dump_f9e6675e",
                                VL_API_GTPU_TUNNEL_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "gtpu_tunnel_details_a4d81a09",
                                VL_API_GTPU_TUNNEL_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "sw_interface_set_gtpu_bypass_65247409",
                                VL_API_SW_INTERFACE_SET_GTPU_BYPASS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "sw_interface_set_gtpu_bypass_reply_e8d4e804",
                                VL_API_SW_INTERFACE_SET_GTPU_BYPASS_REPLY + msg_id_base);
   vl_msg_api_set_handlers(VL_API_GTPU_ADD_DEL_TUNNEL + msg_id_base, "gtpu_add_del_tunnel",
                           vl_api_gtpu_add_del_tunnel_t_handler, vl_noop_handler,
                           vl_api_gtpu_add_del_tunnel_t_endian, vl_api_gtpu_add_del_tunnel_t_print,
                           sizeof(vl_api_gtpu_add_del_tunnel_t), 1);
   vl_msg_api_set_handlers(VL_API_GTPU_TUNNEL_DUMP + msg_id_base, "gtpu_tunnel_dump",
                           vl_api_gtpu_tunnel_dump_t_handler, vl_noop_handler,
                           vl_api_gtpu_tunnel_dump_t_endian, vl_api_gtpu_tunnel_dump_t_print,
                           sizeof(vl_api_gtpu_tunnel_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_SW_INTERFACE_SET_GTPU_BYPASS + msg_id_base, "sw_interface_set_gtpu_bypass",
                           vl_api_sw_interface_set_gtpu_bypass_t_handler, vl_noop_handler,
                           vl_api_sw_interface_set_gtpu_bypass_t_endian, vl_api_sw_interface_set_gtpu_bypass_t_print,
                           sizeof(vl_api_sw_interface_set_gtpu_bypass_t), 1);
   return msg_id_base;
}
