#define vl_endianfun		/* define message structures */
#include "gtpu.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "gtpu.api.h"
#undef vl_printfun

/* Only autoreply is supported (vl_api_gtpu_add_del_tunnel_reply_t_handler()) */
/* Only autoreply is supported (vl_api_gtpu_tunnel_details_t_handler()) */
#ifndef VL_API_SW_INTERFACE_SET_GTPU_BYPASS_REPLY_T_HANDLER
static void
vl_api_sw_interface_set_gtpu_bypass_reply_t_handler (vl_api_sw_interface_set_gtpu_bypass_reply_t * mp) {
   vat_main_t * vam = gtpu_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
static void
setup_message_id_table (vat_main_t * vam, u16 msg_id_base) {
   vl_msg_api_set_handlers(VL_API_GTPU_ADD_DEL_TUNNEL_REPLY + msg_id_base, "gtpu_add_del_tunnel_reply",
                           vl_api_gtpu_add_del_tunnel_reply_t_handler, vl_noop_handler,
                           vl_api_gtpu_add_del_tunnel_reply_t_endian, vl_api_gtpu_add_del_tunnel_reply_t_print,
                           sizeof(vl_api_gtpu_add_del_tunnel_reply_t), 1);
   hash_set_mem (vam->function_by_name, "gtpu_add_del_tunnel", api_gtpu_add_del_tunnel);
   hash_set_mem (vam->help_by_name, "gtpu_add_del_tunnel", "src <ip-addr> { dst <ip-addr> | group <mcast-ip-addr> { <intfc> | mcast_sw_if_index <nn> } } teid <teid> [encap-vrf-id <nn>] [decap-next <l2|nn>] [del]");
   vl_msg_api_set_handlers(VL_API_GTPU_TUNNEL_DETAILS + msg_id_base, "gtpu_tunnel_details",
                           vl_api_gtpu_tunnel_details_t_handler, vl_noop_handler,
                           vl_api_gtpu_tunnel_details_t_endian, vl_api_gtpu_tunnel_details_t_print,
                           sizeof(vl_api_gtpu_tunnel_details_t), 1);
   hash_set_mem (vam->function_by_name, "gtpu_tunnel_dump", api_gtpu_tunnel_dump);
   hash_set_mem (vam->help_by_name, "gtpu_tunnel_dump", "[<intfc> | sw_if_index <nn>]");
   vl_msg_api_set_handlers(VL_API_SW_INTERFACE_SET_GTPU_BYPASS_REPLY + msg_id_base, "sw_interface_set_gtpu_bypass_reply",
                           vl_api_sw_interface_set_gtpu_bypass_reply_t_handler, vl_noop_handler,
                           vl_api_sw_interface_set_gtpu_bypass_reply_t_endian, vl_api_sw_interface_set_gtpu_bypass_reply_t_print,
                           sizeof(vl_api_sw_interface_set_gtpu_bypass_reply_t), 1);
   hash_set_mem (vam->function_by_name, "sw_interface_set_gtpu_bypass", api_sw_interface_set_gtpu_bypass);
   hash_set_mem (vam->help_by_name, "sw_interface_set_gtpu_bypass", "<intfc> | sw_if_index <id> [ip4 | ip6] [enable | disable]");
}
clib_error_t * vat_plugin_register (vat_main_t *vam)
{
   gtpu_test_main_t * mainp = &gtpu_test_main;
   mainp->vat_main = vam;
   mainp->msg_id_base = vl_client_get_first_plugin_msg_id ("gtpu_5342c99b");
   if (mainp->msg_id_base == (u16) ~0)
      return clib_error_return (0, "gtpu plugin not loaded...");
   setup_message_id_table (vam, mainp->msg_id_base);
#ifdef VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE
    VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE(vam);
#endif
   return 0;
}
