#define vl_endianfun		/* define message structures */
#include "igmp.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "igmp.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("igmp_2fd2bd5e", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "igmp_listen_3f93a51a",
                                VL_API_IGMP_LISTEN + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_listen_reply_e8d4e804",
                                VL_API_IGMP_LISTEN_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_enable_disable_b1edfb96",
                                VL_API_IGMP_ENABLE_DISABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_enable_disable_reply_e8d4e804",
                                VL_API_IGMP_ENABLE_DISABLE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_proxy_device_add_del_0b9be9ce",
                                VL_API_IGMP_PROXY_DEVICE_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_proxy_device_add_del_reply_e8d4e804",
                                VL_API_IGMP_PROXY_DEVICE_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_proxy_device_add_del_interface_1a9ec24a",
                                VL_API_IGMP_PROXY_DEVICE_ADD_DEL_INTERFACE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_proxy_device_add_del_interface_reply_e8d4e804",
                                VL_API_IGMP_PROXY_DEVICE_ADD_DEL_INTERFACE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_dump_f9e6675e",
                                VL_API_IGMP_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_details_52f12a89",
                                VL_API_IGMP_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_clear_interface_f9e6675e",
                                VL_API_IGMP_CLEAR_INTERFACE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_clear_interface_reply_e8d4e804",
                                VL_API_IGMP_CLEAR_INTERFACE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "want_igmp_events_cfaccc1f",
                                VL_API_WANT_IGMP_EVENTS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "want_igmp_events_reply_e8d4e804",
                                VL_API_WANT_IGMP_EVENTS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_event_d7696eaf",
                                VL_API_IGMP_EVENT + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_group_prefix_set_d4f20ac5",
                                VL_API_IGMP_GROUP_PREFIX_SET + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_group_prefix_set_reply_e8d4e804",
                                VL_API_IGMP_GROUP_PREFIX_SET_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_group_prefix_dump_51077d14",
                                VL_API_IGMP_GROUP_PREFIX_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "igmp_group_prefix_details_c3b3c526",
                                VL_API_IGMP_GROUP_PREFIX_DETAILS + msg_id_base);
   vl_msg_api_set_handlers(VL_API_WANT_IGMP_EVENTS + msg_id_base, "want_igmp_events",
                           vl_api_want_igmp_events_t_handler, vl_noop_handler,
                           vl_api_want_igmp_events_t_endian, vl_api_want_igmp_events_t_print,
                           sizeof(vl_api_want_igmp_events_t), 1);
   vl_msg_api_set_handlers(VL_API_IGMP_LISTEN + msg_id_base, "igmp_listen",
                           vl_api_igmp_listen_t_handler, vl_noop_handler,
                           vl_api_igmp_listen_t_endian, vl_api_igmp_listen_t_print,
                           sizeof(vl_api_igmp_listen_t), 1);
   vl_msg_api_set_handlers(VL_API_IGMP_ENABLE_DISABLE + msg_id_base, "igmp_enable_disable",
                           vl_api_igmp_enable_disable_t_handler, vl_noop_handler,
                           vl_api_igmp_enable_disable_t_endian, vl_api_igmp_enable_disable_t_print,
                           sizeof(vl_api_igmp_enable_disable_t), 1);
   vl_msg_api_set_handlers(VL_API_IGMP_PROXY_DEVICE_ADD_DEL + msg_id_base, "igmp_proxy_device_add_del",
                           vl_api_igmp_proxy_device_add_del_t_handler, vl_noop_handler,
                           vl_api_igmp_proxy_device_add_del_t_endian, vl_api_igmp_proxy_device_add_del_t_print,
                           sizeof(vl_api_igmp_proxy_device_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_IGMP_PROXY_DEVICE_ADD_DEL_INTERFACE + msg_id_base, "igmp_proxy_device_add_del_interface",
                           vl_api_igmp_proxy_device_add_del_interface_t_handler, vl_noop_handler,
                           vl_api_igmp_proxy_device_add_del_interface_t_endian, vl_api_igmp_proxy_device_add_del_interface_t_print,
                           sizeof(vl_api_igmp_proxy_device_add_del_interface_t), 1);
   vl_msg_api_set_handlers(VL_API_IGMP_DUMP + msg_id_base, "igmp_dump",
                           vl_api_igmp_dump_t_handler, vl_noop_handler,
                           vl_api_igmp_dump_t_endian, vl_api_igmp_dump_t_print,
                           sizeof(vl_api_igmp_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_IGMP_CLEAR_INTERFACE + msg_id_base, "igmp_clear_interface",
                           vl_api_igmp_clear_interface_t_handler, vl_noop_handler,
                           vl_api_igmp_clear_interface_t_endian, vl_api_igmp_clear_interface_t_print,
                           sizeof(vl_api_igmp_clear_interface_t), 1);
   vl_msg_api_set_handlers(VL_API_IGMP_GROUP_PREFIX_SET + msg_id_base, "igmp_group_prefix_set",
                           vl_api_igmp_group_prefix_set_t_handler, vl_noop_handler,
                           vl_api_igmp_group_prefix_set_t_endian, vl_api_igmp_group_prefix_set_t_print,
                           sizeof(vl_api_igmp_group_prefix_set_t), 1);
   vl_msg_api_set_handlers(VL_API_IGMP_GROUP_PREFIX_DUMP + msg_id_base, "igmp_group_prefix_dump",
                           vl_api_igmp_group_prefix_dump_t_handler, vl_noop_handler,
                           vl_api_igmp_group_prefix_dump_t_endian, vl_api_igmp_group_prefix_dump_t_print,
                           sizeof(vl_api_igmp_group_prefix_dump_t), 1);
   return msg_id_base;
}
