#define vl_endianfun		/* define message structures */
#include "ikev2.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "ikev2.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("ikev2_4983c0b5", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "ikev2_plugin_get_version_51077d14",
                                VL_API_IKEV2_PLUGIN_GET_VERSION + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_plugin_get_version_reply_9b32cf86",
                                VL_API_IKEV2_PLUGIN_GET_VERSION_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_profile_add_del_2c925b55",
                                VL_API_IKEV2_PROFILE_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_profile_add_del_reply_e8d4e804",
                                VL_API_IKEV2_PROFILE_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_profile_set_auth_642c97cd",
                                VL_API_IKEV2_PROFILE_SET_AUTH + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_profile_set_auth_reply_e8d4e804",
                                VL_API_IKEV2_PROFILE_SET_AUTH_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_profile_set_id_4d7e2418",
                                VL_API_IKEV2_PROFILE_SET_ID + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_profile_set_id_reply_e8d4e804",
                                VL_API_IKEV2_PROFILE_SET_ID_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_profile_set_ts_64d55c16",
                                VL_API_IKEV2_PROFILE_SET_TS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_profile_set_ts_reply_e8d4e804",
                                VL_API_IKEV2_PROFILE_SET_TS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_set_local_key_e4996cd5",
                                VL_API_IKEV2_SET_LOCAL_KEY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_set_local_key_reply_e8d4e804",
                                VL_API_IKEV2_SET_LOCAL_KEY_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_set_responder_f0d3dc80",
                                VL_API_IKEV2_SET_RESPONDER + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_set_responder_reply_e8d4e804",
                                VL_API_IKEV2_SET_RESPONDER_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_set_ike_transforms_936a1a37",
                                VL_API_IKEV2_SET_IKE_TRANSFORMS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_set_ike_transforms_reply_e8d4e804",
                                VL_API_IKEV2_SET_IKE_TRANSFORMS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_set_esp_transforms_936a1a37",
                                VL_API_IKEV2_SET_ESP_TRANSFORMS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_set_esp_transforms_reply_e8d4e804",
                                VL_API_IKEV2_SET_ESP_TRANSFORMS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_set_sa_lifetime_7039feaa",
                                VL_API_IKEV2_SET_SA_LIFETIME + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_set_sa_lifetime_reply_e8d4e804",
                                VL_API_IKEV2_SET_SA_LIFETIME_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_initiate_sa_init_ebf79a66",
                                VL_API_IKEV2_INITIATE_SA_INIT + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_initiate_sa_init_reply_e8d4e804",
                                VL_API_IKEV2_INITIATE_SA_INIT_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_initiate_del_ike_sa_8d125bdd",
                                VL_API_IKEV2_INITIATE_DEL_IKE_SA + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_initiate_del_ike_sa_reply_e8d4e804",
                                VL_API_IKEV2_INITIATE_DEL_IKE_SA_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_initiate_del_child_sa_7f004d2e",
                                VL_API_IKEV2_INITIATE_DEL_CHILD_SA + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_initiate_del_child_sa_reply_e8d4e804",
                                VL_API_IKEV2_INITIATE_DEL_CHILD_SA_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_initiate_rekey_child_sa_7f004d2e",
                                VL_API_IKEV2_INITIATE_REKEY_CHILD_SA + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ikev2_initiate_rekey_child_sa_reply_e8d4e804",
                                VL_API_IKEV2_INITIATE_REKEY_CHILD_SA_REPLY + msg_id_base);
   vl_msg_api_set_handlers(VL_API_IKEV2_PLUGIN_GET_VERSION + msg_id_base, "ikev2_plugin_get_version",
                           vl_api_ikev2_plugin_get_version_t_handler, vl_noop_handler,
                           vl_api_ikev2_plugin_get_version_t_endian, vl_api_ikev2_plugin_get_version_t_print,
                           sizeof(vl_api_ikev2_plugin_get_version_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_PROFILE_ADD_DEL + msg_id_base, "ikev2_profile_add_del",
                           vl_api_ikev2_profile_add_del_t_handler, vl_noop_handler,
                           vl_api_ikev2_profile_add_del_t_endian, vl_api_ikev2_profile_add_del_t_print,
                           sizeof(vl_api_ikev2_profile_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_PROFILE_SET_AUTH + msg_id_base, "ikev2_profile_set_auth",
                           vl_api_ikev2_profile_set_auth_t_handler, vl_noop_handler,
                           vl_api_ikev2_profile_set_auth_t_endian, vl_api_ikev2_profile_set_auth_t_print,
                           sizeof(vl_api_ikev2_profile_set_auth_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_PROFILE_SET_ID + msg_id_base, "ikev2_profile_set_id",
                           vl_api_ikev2_profile_set_id_t_handler, vl_noop_handler,
                           vl_api_ikev2_profile_set_id_t_endian, vl_api_ikev2_profile_set_id_t_print,
                           sizeof(vl_api_ikev2_profile_set_id_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_PROFILE_SET_TS + msg_id_base, "ikev2_profile_set_ts",
                           vl_api_ikev2_profile_set_ts_t_handler, vl_noop_handler,
                           vl_api_ikev2_profile_set_ts_t_endian, vl_api_ikev2_profile_set_ts_t_print,
                           sizeof(vl_api_ikev2_profile_set_ts_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_SET_LOCAL_KEY + msg_id_base, "ikev2_set_local_key",
                           vl_api_ikev2_set_local_key_t_handler, vl_noop_handler,
                           vl_api_ikev2_set_local_key_t_endian, vl_api_ikev2_set_local_key_t_print,
                           sizeof(vl_api_ikev2_set_local_key_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_SET_RESPONDER + msg_id_base, "ikev2_set_responder",
                           vl_api_ikev2_set_responder_t_handler, vl_noop_handler,
                           vl_api_ikev2_set_responder_t_endian, vl_api_ikev2_set_responder_t_print,
                           sizeof(vl_api_ikev2_set_responder_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_SET_IKE_TRANSFORMS + msg_id_base, "ikev2_set_ike_transforms",
                           vl_api_ikev2_set_ike_transforms_t_handler, vl_noop_handler,
                           vl_api_ikev2_set_ike_transforms_t_endian, vl_api_ikev2_set_ike_transforms_t_print,
                           sizeof(vl_api_ikev2_set_ike_transforms_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_SET_ESP_TRANSFORMS + msg_id_base, "ikev2_set_esp_transforms",
                           vl_api_ikev2_set_esp_transforms_t_handler, vl_noop_handler,
                           vl_api_ikev2_set_esp_transforms_t_endian, vl_api_ikev2_set_esp_transforms_t_print,
                           sizeof(vl_api_ikev2_set_esp_transforms_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_SET_SA_LIFETIME + msg_id_base, "ikev2_set_sa_lifetime",
                           vl_api_ikev2_set_sa_lifetime_t_handler, vl_noop_handler,
                           vl_api_ikev2_set_sa_lifetime_t_endian, vl_api_ikev2_set_sa_lifetime_t_print,
                           sizeof(vl_api_ikev2_set_sa_lifetime_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_INITIATE_SA_INIT + msg_id_base, "ikev2_initiate_sa_init",
                           vl_api_ikev2_initiate_sa_init_t_handler, vl_noop_handler,
                           vl_api_ikev2_initiate_sa_init_t_endian, vl_api_ikev2_initiate_sa_init_t_print,
                           sizeof(vl_api_ikev2_initiate_sa_init_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_INITIATE_DEL_IKE_SA + msg_id_base, "ikev2_initiate_del_ike_sa",
                           vl_api_ikev2_initiate_del_ike_sa_t_handler, vl_noop_handler,
                           vl_api_ikev2_initiate_del_ike_sa_t_endian, vl_api_ikev2_initiate_del_ike_sa_t_print,
                           sizeof(vl_api_ikev2_initiate_del_ike_sa_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_INITIATE_DEL_CHILD_SA + msg_id_base, "ikev2_initiate_del_child_sa",
                           vl_api_ikev2_initiate_del_child_sa_t_handler, vl_noop_handler,
                           vl_api_ikev2_initiate_del_child_sa_t_endian, vl_api_ikev2_initiate_del_child_sa_t_print,
                           sizeof(vl_api_ikev2_initiate_del_child_sa_t), 1);
   vl_msg_api_set_handlers(VL_API_IKEV2_INITIATE_REKEY_CHILD_SA + msg_id_base, "ikev2_initiate_rekey_child_sa",
                           vl_api_ikev2_initiate_rekey_child_sa_t_handler, vl_noop_handler,
                           vl_api_ikev2_initiate_rekey_child_sa_t_endian, vl_api_ikev2_initiate_rekey_child_sa_t_print,
                           sizeof(vl_api_ikev2_initiate_rekey_child_sa_t), 1);
   return msg_id_base;
}
