#define vl_endianfun		/* define message structures */
#include "pot.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "pot.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("pot_a9d8e55c", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "pot_profile_add_ad5da3a3",
                                VL_API_POT_PROFILE_ADD + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "pot_profile_add_reply_e8d4e804",
                                VL_API_POT_PROFILE_ADD_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "pot_profile_activate_0770af98",
                                VL_API_POT_PROFILE_ACTIVATE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "pot_profile_activate_reply_e8d4e804",
                                VL_API_POT_PROFILE_ACTIVATE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "pot_profile_del_cd63f53b",
                                VL_API_POT_PROFILE_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "pot_profile_del_reply_e8d4e804",
                                VL_API_POT_PROFILE_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "pot_profile_show_config_dump_005b7d59",
                                VL_API_POT_PROFILE_SHOW_CONFIG_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "pot_profile_show_config_details_b7ce0618",
                                VL_API_POT_PROFILE_SHOW_CONFIG_DETAILS + msg_id_base);
   vl_msg_api_set_handlers(VL_API_POT_PROFILE_ADD + msg_id_base, "pot_profile_add",
                           vl_api_pot_profile_add_t_handler, vl_noop_handler,
                           vl_api_pot_profile_add_t_endian, vl_api_pot_profile_add_t_print,
                           sizeof(vl_api_pot_profile_add_t), 1);
   vl_msg_api_set_handlers(VL_API_POT_PROFILE_ACTIVATE + msg_id_base, "pot_profile_activate",
                           vl_api_pot_profile_activate_t_handler, vl_noop_handler,
                           vl_api_pot_profile_activate_t_endian, vl_api_pot_profile_activate_t_print,
                           sizeof(vl_api_pot_profile_activate_t), 1);
   vl_msg_api_set_handlers(VL_API_POT_PROFILE_DEL + msg_id_base, "pot_profile_del",
                           vl_api_pot_profile_del_t_handler, vl_noop_handler,
                           vl_api_pot_profile_del_t_endian, vl_api_pot_profile_del_t_print,
                           sizeof(vl_api_pot_profile_del_t), 1);
   vl_msg_api_set_handlers(VL_API_POT_PROFILE_SHOW_CONFIG_DUMP + msg_id_base, "pot_profile_show_config_dump",
                           vl_api_pot_profile_show_config_dump_t_handler, vl_noop_handler,
                           vl_api_pot_profile_show_config_dump_t_endian, vl_api_pot_profile_show_config_dump_t_print,
                           sizeof(vl_api_pot_profile_show_config_dump_t), 1);
   return msg_id_base;
}
