#define vl_endianfun		/* define message structures */
#include "ioam_vxlan_gpe.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "ioam_vxlan_gpe.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("ioam_vxlan_gpe_b9e086eb", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_enable_2481bef7",
                                VL_API_VXLAN_GPE_IOAM_ENABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_enable_reply_e8d4e804",
                                VL_API_VXLAN_GPE_IOAM_ENABLE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_disable_6b16a45e",
                                VL_API_VXLAN_GPE_IOAM_DISABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_disable_reply_e8d4e804",
                                VL_API_VXLAN_GPE_IOAM_DISABLE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_vni_enable_997161fb",
                                VL_API_VXLAN_GPE_IOAM_VNI_ENABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_vni_enable_reply_e8d4e804",
                                VL_API_VXLAN_GPE_IOAM_VNI_ENABLE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_vni_disable_997161fb",
                                VL_API_VXLAN_GPE_IOAM_VNI_DISABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_vni_disable_reply_e8d4e804",
                                VL_API_VXLAN_GPE_IOAM_VNI_DISABLE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_transit_enable_553f5b7b",
                                VL_API_VXLAN_GPE_IOAM_TRANSIT_ENABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_transit_enable_reply_e8d4e804",
                                VL_API_VXLAN_GPE_IOAM_TRANSIT_ENABLE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_transit_disable_553f5b7b",
                                VL_API_VXLAN_GPE_IOAM_TRANSIT_DISABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "vxlan_gpe_ioam_transit_disable_reply_e8d4e804",
                                VL_API_VXLAN_GPE_IOAM_TRANSIT_DISABLE_REPLY + msg_id_base);
   vl_msg_api_set_handlers(VL_API_VXLAN_GPE_IOAM_ENABLE + msg_id_base, "vxlan_gpe_ioam_enable",
                           vl_api_vxlan_gpe_ioam_enable_t_handler, vl_noop_handler,
                           vl_api_vxlan_gpe_ioam_enable_t_endian, vl_api_vxlan_gpe_ioam_enable_t_print,
                           sizeof(vl_api_vxlan_gpe_ioam_enable_t), 1);
   vl_msg_api_set_handlers(VL_API_VXLAN_GPE_IOAM_DISABLE + msg_id_base, "vxlan_gpe_ioam_disable",
                           vl_api_vxlan_gpe_ioam_disable_t_handler, vl_noop_handler,
                           vl_api_vxlan_gpe_ioam_disable_t_endian, vl_api_vxlan_gpe_ioam_disable_t_print,
                           sizeof(vl_api_vxlan_gpe_ioam_disable_t), 1);
   vl_msg_api_set_handlers(VL_API_VXLAN_GPE_IOAM_VNI_ENABLE + msg_id_base, "vxlan_gpe_ioam_vni_enable",
                           vl_api_vxlan_gpe_ioam_vni_enable_t_handler, vl_noop_handler,
                           vl_api_vxlan_gpe_ioam_vni_enable_t_endian, vl_api_vxlan_gpe_ioam_vni_enable_t_print,
                           sizeof(vl_api_vxlan_gpe_ioam_vni_enable_t), 1);
   vl_msg_api_set_handlers(VL_API_VXLAN_GPE_IOAM_VNI_DISABLE + msg_id_base, "vxlan_gpe_ioam_vni_disable",
                           vl_api_vxlan_gpe_ioam_vni_disable_t_handler, vl_noop_handler,
                           vl_api_vxlan_gpe_ioam_vni_disable_t_endian, vl_api_vxlan_gpe_ioam_vni_disable_t_print,
                           sizeof(vl_api_vxlan_gpe_ioam_vni_disable_t), 1);
   vl_msg_api_set_handlers(VL_API_VXLAN_GPE_IOAM_TRANSIT_ENABLE + msg_id_base, "vxlan_gpe_ioam_transit_enable",
                           vl_api_vxlan_gpe_ioam_transit_enable_t_handler, vl_noop_handler,
                           vl_api_vxlan_gpe_ioam_transit_enable_t_endian, vl_api_vxlan_gpe_ioam_transit_enable_t_print,
                           sizeof(vl_api_vxlan_gpe_ioam_transit_enable_t), 1);
   vl_msg_api_set_handlers(VL_API_VXLAN_GPE_IOAM_TRANSIT_DISABLE + msg_id_base, "vxlan_gpe_ioam_transit_disable",
                           vl_api_vxlan_gpe_ioam_transit_disable_t_handler, vl_noop_handler,
                           vl_api_vxlan_gpe_ioam_transit_disable_t_endian, vl_api_vxlan_gpe_ioam_transit_disable_t_print,
                           sizeof(vl_api_vxlan_gpe_ioam_transit_disable_t), 1);
   return msg_id_base;
}
