#define vl_endianfun		/* define message structures */
#include "lacp.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "lacp.api.h"
#undef vl_printfun

/* Only autoreply is supported (vl_api_sw_interface_lacp_details_t_handler()) */
static void
setup_message_id_table (vat_main_t * vam, u16 msg_id_base) {
   vl_msg_api_set_handlers(VL_API_SW_INTERFACE_LACP_DETAILS + msg_id_base, "sw_interface_lacp_details",
                           vl_api_sw_interface_lacp_details_t_handler, vl_noop_handler,
                           vl_api_sw_interface_lacp_details_t_endian, vl_api_sw_interface_lacp_details_t_print,
                           sizeof(vl_api_sw_interface_lacp_details_t), 1);
   hash_set_mem (vam->function_by_name, "sw_interface_lacp_dump", api_sw_interface_lacp_dump);
}
clib_error_t * vat_plugin_register (vat_main_t *vam)
{
   lacp_test_main_t * mainp = &lacp_test_main;
   mainp->vat_main = vam;
   mainp->msg_id_base = vl_client_get_first_plugin_msg_id ("lacp_8975258e");
   if (mainp->msg_id_base == (u16) ~0)
      return clib_error_return (0, "lacp plugin not loaded...");
   setup_message_id_table (vam, mainp->msg_id_base);
#ifdef VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE
    VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE(vam);
#endif
   return 0;
}
