#define vl_endianfun		/* define message structures */
#include "lb.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "lb.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("lb_08e973b2", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "lb_conf_22ddb739",
                                VL_API_LB_CONF + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_conf_reply_e8d4e804",
                                VL_API_LB_CONF_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_add_del_vip_d15b7ddc",
                                VL_API_LB_ADD_DEL_VIP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_add_del_vip_reply_e8d4e804",
                                VL_API_LB_ADD_DEL_VIP_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_add_del_as_78628987",
                                VL_API_LB_ADD_DEL_AS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_add_del_as_reply_e8d4e804",
                                VL_API_LB_ADD_DEL_AS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_flush_vip_1063f819",
                                VL_API_LB_FLUSH_VIP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_flush_vip_reply_e8d4e804",
                                VL_API_LB_FLUSH_VIP_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_vip_dump_c7bcb124",
                                VL_API_LB_VIP_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_vip_details_08f39bed",
                                VL_API_LB_VIP_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_as_dump_1063f819",
                                VL_API_LB_AS_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_as_details_9c39f60e",
                                VL_API_LB_AS_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_add_del_intf_nat4_47d6e753",
                                VL_API_LB_ADD_DEL_INTF_NAT4 + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_add_del_intf_nat4_reply_e8d4e804",
                                VL_API_LB_ADD_DEL_INTF_NAT4_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_add_del_intf_nat6_47d6e753",
                                VL_API_LB_ADD_DEL_INTF_NAT6 + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "lb_add_del_intf_nat6_reply_e8d4e804",
                                VL_API_LB_ADD_DEL_INTF_NAT6_REPLY + msg_id_base);
   vl_msg_api_set_handlers(VL_API_LB_CONF + msg_id_base, "lb_conf",
                           vl_api_lb_conf_t_handler, vl_noop_handler,
                           vl_api_lb_conf_t_endian, vl_api_lb_conf_t_print,
                           sizeof(vl_api_lb_conf_t), 1);
   vl_msg_api_set_handlers(VL_API_LB_ADD_DEL_VIP + msg_id_base, "lb_add_del_vip",
                           vl_api_lb_add_del_vip_t_handler, vl_noop_handler,
                           vl_api_lb_add_del_vip_t_endian, vl_api_lb_add_del_vip_t_print,
                           sizeof(vl_api_lb_add_del_vip_t), 1);
   vl_msg_api_set_handlers(VL_API_LB_ADD_DEL_AS + msg_id_base, "lb_add_del_as",
                           vl_api_lb_add_del_as_t_handler, vl_noop_handler,
                           vl_api_lb_add_del_as_t_endian, vl_api_lb_add_del_as_t_print,
                           sizeof(vl_api_lb_add_del_as_t), 1);
   vl_msg_api_set_handlers(VL_API_LB_FLUSH_VIP + msg_id_base, "lb_flush_vip",
                           vl_api_lb_flush_vip_t_handler, vl_noop_handler,
                           vl_api_lb_flush_vip_t_endian, vl_api_lb_flush_vip_t_print,
                           sizeof(vl_api_lb_flush_vip_t), 1);
   vl_msg_api_set_handlers(VL_API_LB_VIP_DUMP + msg_id_base, "lb_vip_dump",
                           vl_api_lb_vip_dump_t_handler, vl_noop_handler,
                           vl_api_lb_vip_dump_t_endian, vl_api_lb_vip_dump_t_print,
                           sizeof(vl_api_lb_vip_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_LB_AS_DUMP + msg_id_base, "lb_as_dump",
                           vl_api_lb_as_dump_t_handler, vl_noop_handler,
                           vl_api_lb_as_dump_t_endian, vl_api_lb_as_dump_t_print,
                           sizeof(vl_api_lb_as_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_LB_ADD_DEL_INTF_NAT4 + msg_id_base, "lb_add_del_intf_nat4",
                           vl_api_lb_add_del_intf_nat4_t_handler, vl_noop_handler,
                           vl_api_lb_add_del_intf_nat4_t_endian, vl_api_lb_add_del_intf_nat4_t_print,
                           sizeof(vl_api_lb_add_del_intf_nat4_t), 1);
   vl_msg_api_set_handlers(VL_API_LB_ADD_DEL_INTF_NAT6 + msg_id_base, "lb_add_del_intf_nat6",
                           vl_api_lb_add_del_intf_nat6_t_handler, vl_noop_handler,
                           vl_api_lb_add_del_intf_nat6_t_endian, vl_api_lb_add_del_intf_nat6_t_print,
                           sizeof(vl_api_lb_add_del_intf_nat6_t), 1);
   return msg_id_base;
}
