#define vl_endianfun		/* define message structures */
#include "map.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "map.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("map_57fa1ca6", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "map_add_domain_7a5a18c9",
                                VL_API_MAP_ADD_DOMAIN + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_add_domain_reply_3e6d4e2c",
                                VL_API_MAP_ADD_DOMAIN_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_del_domain_8ac76db6",
                                VL_API_MAP_DEL_DOMAIN + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_del_domain_reply_e8d4e804",
                                VL_API_MAP_DEL_DOMAIN_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_add_del_rule_c65b32f7",
                                VL_API_MAP_ADD_DEL_RULE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_add_del_rule_reply_e8d4e804",
                                VL_API_MAP_ADD_DEL_RULE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_domain_dump_51077d14",
                                VL_API_MAP_DOMAIN_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_domain_details_fc1859dd",
                                VL_API_MAP_DOMAIN_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_rule_dump_e43e6ff6",
                                VL_API_MAP_RULE_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_rule_details_c7cbeea5",
                                VL_API_MAP_RULE_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_if_enable_disable_59bb32f4",
                                VL_API_MAP_IF_ENABLE_DISABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_if_enable_disable_reply_e8d4e804",
                                VL_API_MAP_IF_ENABLE_DISABLE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_summary_stats_51077d14",
                                VL_API_MAP_SUMMARY_STATS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_summary_stats_reply_0e4ace0e",
                                VL_API_MAP_SUMMARY_STATS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_fragmentation_9ff54d90",
                                VL_API_MAP_PARAM_SET_FRAGMENTATION + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_fragmentation_reply_e8d4e804",
                                VL_API_MAP_PARAM_SET_FRAGMENTATION_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_icmp_58210cbf",
                                VL_API_MAP_PARAM_SET_ICMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_icmp_reply_e8d4e804",
                                VL_API_MAP_PARAM_SET_ICMP_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_icmp6_5d01f8c1",
                                VL_API_MAP_PARAM_SET_ICMP6 + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_icmp6_reply_e8d4e804",
                                VL_API_MAP_PARAM_SET_ICMP6_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_add_del_pre_resolve_17008c66",
                                VL_API_MAP_PARAM_ADD_DEL_PRE_RESOLVE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_add_del_pre_resolve_reply_e8d4e804",
                                VL_API_MAP_PARAM_ADD_DEL_PRE_RESOLVE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_security_check_6abe9836",
                                VL_API_MAP_PARAM_SET_SECURITY_CHECK + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_security_check_reply_e8d4e804",
                                VL_API_MAP_PARAM_SET_SECURITY_CHECK_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_traffic_class_9cac455c",
                                VL_API_MAP_PARAM_SET_TRAFFIC_CLASS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_traffic_class_reply_e8d4e804",
                                VL_API_MAP_PARAM_SET_TRAFFIC_CLASS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_tcp_87a825d9",
                                VL_API_MAP_PARAM_SET_TCP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_set_tcp_reply_e8d4e804",
                                VL_API_MAP_PARAM_SET_TCP_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_get_51077d14",
                                VL_API_MAP_PARAM_GET + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "map_param_get_reply_28092156",
                                VL_API_MAP_PARAM_GET_REPLY + msg_id_base);
   vl_msg_api_set_handlers(VL_API_MAP_ADD_DOMAIN + msg_id_base, "map_add_domain",
                           vl_api_map_add_domain_t_handler, vl_noop_handler,
                           vl_api_map_add_domain_t_endian, vl_api_map_add_domain_t_print,
                           sizeof(vl_api_map_add_domain_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_DEL_DOMAIN + msg_id_base, "map_del_domain",
                           vl_api_map_del_domain_t_handler, vl_noop_handler,
                           vl_api_map_del_domain_t_endian, vl_api_map_del_domain_t_print,
                           sizeof(vl_api_map_del_domain_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_ADD_DEL_RULE + msg_id_base, "map_add_del_rule",
                           vl_api_map_add_del_rule_t_handler, vl_noop_handler,
                           vl_api_map_add_del_rule_t_endian, vl_api_map_add_del_rule_t_print,
                           sizeof(vl_api_map_add_del_rule_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_DOMAIN_DUMP + msg_id_base, "map_domain_dump",
                           vl_api_map_domain_dump_t_handler, vl_noop_handler,
                           vl_api_map_domain_dump_t_endian, vl_api_map_domain_dump_t_print,
                           sizeof(vl_api_map_domain_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_RULE_DUMP + msg_id_base, "map_rule_dump",
                           vl_api_map_rule_dump_t_handler, vl_noop_handler,
                           vl_api_map_rule_dump_t_endian, vl_api_map_rule_dump_t_print,
                           sizeof(vl_api_map_rule_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_IF_ENABLE_DISABLE + msg_id_base, "map_if_enable_disable",
                           vl_api_map_if_enable_disable_t_handler, vl_noop_handler,
                           vl_api_map_if_enable_disable_t_endian, vl_api_map_if_enable_disable_t_print,
                           sizeof(vl_api_map_if_enable_disable_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_SUMMARY_STATS + msg_id_base, "map_summary_stats",
                           vl_api_map_summary_stats_t_handler, vl_noop_handler,
                           vl_api_map_summary_stats_t_endian, vl_api_map_summary_stats_t_print,
                           sizeof(vl_api_map_summary_stats_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_PARAM_SET_FRAGMENTATION + msg_id_base, "map_param_set_fragmentation",
                           vl_api_map_param_set_fragmentation_t_handler, vl_noop_handler,
                           vl_api_map_param_set_fragmentation_t_endian, vl_api_map_param_set_fragmentation_t_print,
                           sizeof(vl_api_map_param_set_fragmentation_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_PARAM_SET_ICMP + msg_id_base, "map_param_set_icmp",
                           vl_api_map_param_set_icmp_t_handler, vl_noop_handler,
                           vl_api_map_param_set_icmp_t_endian, vl_api_map_param_set_icmp_t_print,
                           sizeof(vl_api_map_param_set_icmp_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_PARAM_SET_ICMP6 + msg_id_base, "map_param_set_icmp6",
                           vl_api_map_param_set_icmp6_t_handler, vl_noop_handler,
                           vl_api_map_param_set_icmp6_t_endian, vl_api_map_param_set_icmp6_t_print,
                           sizeof(vl_api_map_param_set_icmp6_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_PARAM_ADD_DEL_PRE_RESOLVE + msg_id_base, "map_param_add_del_pre_resolve",
                           vl_api_map_param_add_del_pre_resolve_t_handler, vl_noop_handler,
                           vl_api_map_param_add_del_pre_resolve_t_endian, vl_api_map_param_add_del_pre_resolve_t_print,
                           sizeof(vl_api_map_param_add_del_pre_resolve_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_PARAM_SET_SECURITY_CHECK + msg_id_base, "map_param_set_security_check",
                           vl_api_map_param_set_security_check_t_handler, vl_noop_handler,
                           vl_api_map_param_set_security_check_t_endian, vl_api_map_param_set_security_check_t_print,
                           sizeof(vl_api_map_param_set_security_check_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_PARAM_SET_TRAFFIC_CLASS + msg_id_base, "map_param_set_traffic_class",
                           vl_api_map_param_set_traffic_class_t_handler, vl_noop_handler,
                           vl_api_map_param_set_traffic_class_t_endian, vl_api_map_param_set_traffic_class_t_print,
                           sizeof(vl_api_map_param_set_traffic_class_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_PARAM_SET_TCP + msg_id_base, "map_param_set_tcp",
                           vl_api_map_param_set_tcp_t_handler, vl_noop_handler,
                           vl_api_map_param_set_tcp_t_endian, vl_api_map_param_set_tcp_t_print,
                           sizeof(vl_api_map_param_set_tcp_t), 1);
   vl_msg_api_set_handlers(VL_API_MAP_PARAM_GET + msg_id_base, "map_param_get",
                           vl_api_map_param_get_t_handler, vl_noop_handler,
                           vl_api_map_param_get_t_endian, vl_api_map_param_get_t_print,
                           sizeof(vl_api_map_param_get_t), 1);
   return msg_id_base;
}
