#define vl_endianfun		/* define message structures */
#include "memif.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "memif.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("memif_1cebc00e", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "memif_socket_filename_add_del_a2ce1a10",
                                VL_API_MEMIF_SOCKET_FILENAME_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "memif_socket_filename_add_del_reply_e8d4e804",
                                VL_API_MEMIF_SOCKET_FILENAME_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "memif_create_b1b25061",
                                VL_API_MEMIF_CREATE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "memif_create_reply_5383d31f",
                                VL_API_MEMIF_CREATE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "memif_delete_f9e6675e",
                                VL_API_MEMIF_DELETE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "memif_delete_reply_e8d4e804",
                                VL_API_MEMIF_DELETE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "memif_socket_filename_details_7ff326f7",
                                VL_API_MEMIF_SOCKET_FILENAME_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "memif_socket_filename_dump_51077d14",
                                VL_API_MEMIF_SOCKET_FILENAME_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "memif_details_d0382c4c",
                                VL_API_MEMIF_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "memif_dump_51077d14",
                                VL_API_MEMIF_DUMP + msg_id_base);
   vl_msg_api_set_handlers(VL_API_MEMIF_SOCKET_FILENAME_ADD_DEL + msg_id_base, "memif_socket_filename_add_del",
                           vl_api_memif_socket_filename_add_del_t_handler, vl_noop_handler,
                           vl_api_memif_socket_filename_add_del_t_endian, vl_api_memif_socket_filename_add_del_t_print,
                           sizeof(vl_api_memif_socket_filename_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_MEMIF_CREATE + msg_id_base, "memif_create",
                           vl_api_memif_create_t_handler, vl_noop_handler,
                           vl_api_memif_create_t_endian, vl_api_memif_create_t_print,
                           sizeof(vl_api_memif_create_t), 1);
   vl_msg_api_set_handlers(VL_API_MEMIF_DELETE + msg_id_base, "memif_delete",
                           vl_api_memif_delete_t_handler, vl_noop_handler,
                           vl_api_memif_delete_t_endian, vl_api_memif_delete_t_print,
                           sizeof(vl_api_memif_delete_t), 1);
   vl_msg_api_set_handlers(VL_API_MEMIF_SOCKET_FILENAME_DUMP + msg_id_base, "memif_socket_filename_dump",
                           vl_api_memif_socket_filename_dump_t_handler, vl_noop_handler,
                           vl_api_memif_socket_filename_dump_t_endian, vl_api_memif_socket_filename_dump_t_print,
                           sizeof(vl_api_memif_socket_filename_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_MEMIF_DUMP + msg_id_base, "memif_dump",
                           vl_api_memif_dump_t_handler, vl_noop_handler,
                           vl_api_memif_dump_t_endian, vl_api_memif_dump_t_print,
                           sizeof(vl_api_memif_dump_t), 1);
   return msg_id_base;
}
