#define vl_endianfun		/* define message structures */
#include "sctp.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "sctp.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("sctp_35f411c4", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "sctp_add_src_dst_connection_45c59b2f",
                                VL_API_SCTP_ADD_SRC_DST_CONNECTION + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "sctp_add_src_dst_connection_reply_e8d4e804",
                                VL_API_SCTP_ADD_SRC_DST_CONNECTION_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "sctp_del_src_dst_connection_45c59b2f",
                                VL_API_SCTP_DEL_SRC_DST_CONNECTION + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "sctp_del_src_dst_connection_reply_e8d4e804",
                                VL_API_SCTP_DEL_SRC_DST_CONNECTION_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "sctp_config_7617eced",
                                VL_API_SCTP_CONFIG + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "sctp_config_reply_e8d4e804",
                                VL_API_SCTP_CONFIG_REPLY + msg_id_base);
   vl_msg_api_set_handlers(VL_API_SCTP_ADD_SRC_DST_CONNECTION + msg_id_base, "sctp_add_src_dst_connection",
                           vl_api_sctp_add_src_dst_connection_t_handler, vl_noop_handler,
                           vl_api_sctp_add_src_dst_connection_t_endian, vl_api_sctp_add_src_dst_connection_t_print,
                           sizeof(vl_api_sctp_add_src_dst_connection_t), 1);
   vl_msg_api_set_handlers(VL_API_SCTP_DEL_SRC_DST_CONNECTION + msg_id_base, "sctp_del_src_dst_connection",
                           vl_api_sctp_del_src_dst_connection_t_handler, vl_noop_handler,
                           vl_api_sctp_del_src_dst_connection_t_endian, vl_api_sctp_del_src_dst_connection_t_print,
                           sizeof(vl_api_sctp_del_src_dst_connection_t), 1);
   vl_msg_api_set_handlers(VL_API_SCTP_CONFIG + msg_id_base, "sctp_config",
                           vl_api_sctp_config_t_handler, vl_noop_handler,
                           vl_api_sctp_config_t_endian, vl_api_sctp_config_t_print,
                           sizeof(vl_api_sctp_config_t), 1);
   return msg_id_base;
}
