#define vl_endianfun		/* define message structures */
#include "vmxnet3.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "vmxnet3.api.h"
#undef vl_printfun

/* Only autoreply is supported (vl_api_vmxnet3_create_reply_t_handler()) */
#ifndef VL_API_VMXNET3_DELETE_REPLY_T_HANDLER
static void
vl_api_vmxnet3_delete_reply_t_handler (vl_api_vmxnet3_delete_reply_t * mp) {
   vat_main_t * vam = vmxnet3_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
/* Only autoreply is supported (vl_api_vmxnet3_details_t_handler()) */
static void
setup_message_id_table (vat_main_t * vam, u16 msg_id_base) {
   vl_msg_api_set_handlers(VL_API_VMXNET3_CREATE_REPLY + msg_id_base, "vmxnet3_create_reply",
                           vl_api_vmxnet3_create_reply_t_handler, vl_noop_handler,
                           vl_api_vmxnet3_create_reply_t_endian, vl_api_vmxnet3_create_reply_t_print,
                           sizeof(vl_api_vmxnet3_create_reply_t), 1);
   hash_set_mem (vam->function_by_name, "vmxnet3_create", api_vmxnet3_create);
   hash_set_mem (vam->help_by_name, "vmxnet3_create", "<pci-address> [rx-queue-size <size>] [tx-queue-size <size>] [num-tx-queues <num>] [num-rx-queues <num>] [bind] [gso]");
   vl_msg_api_set_handlers(VL_API_VMXNET3_DELETE_REPLY + msg_id_base, "vmxnet3_delete_reply",
                           vl_api_vmxnet3_delete_reply_t_handler, vl_noop_handler,
                           vl_api_vmxnet3_delete_reply_t_endian, vl_api_vmxnet3_delete_reply_t_print,
                           sizeof(vl_api_vmxnet3_delete_reply_t), 1);
   hash_set_mem (vam->function_by_name, "vmxnet3_delete", api_vmxnet3_delete);
   hash_set_mem (vam->help_by_name, "vmxnet3_delete", "sw_if_index <sw_if_index>");
   vl_msg_api_set_handlers(VL_API_VMXNET3_DETAILS + msg_id_base, "vmxnet3_details",
                           vl_api_vmxnet3_details_t_handler, vl_noop_handler,
                           vl_api_vmxnet3_details_t_endian, vl_api_vmxnet3_details_t_print,
                           sizeof(vl_api_vmxnet3_details_t), 1);
   hash_set_mem (vam->function_by_name, "vmxnet3_dump", api_vmxnet3_dump);
}
clib_error_t * vat_plugin_register (vat_main_t *vam)
{
   vmxnet3_test_main_t * mainp = &vmxnet3_test_main;
   mainp->vat_main = vam;
   mainp->msg_id_base = vl_client_get_first_plugin_msg_id ("vmxnet3_0cd055e9");
   if (mainp->msg_id_base == (u16) ~0)
      return clib_error_return (0, "vmxnet3 plugin not loaded...");
   setup_message_id_table (vam, mainp->msg_id_base);
#ifdef VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE
    VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE(vam);
#endif
   return 0;
}
