#define vl_endianfun		/* define message structures */
#include "arp.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "arp.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("arp_cfdf7292", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "proxy_arp_add_del_85486cbd",
                                VL_API_PROXY_ARP_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "proxy_arp_add_del_reply_e8d4e804",
                                VL_API_PROXY_ARP_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "proxy_arp_dump_51077d14",
                                VL_API_PROXY_ARP_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "proxy_arp_details_9228c150",
                                VL_API_PROXY_ARP_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "proxy_arp_intfc_enable_disable_ae6cfcfb",
                                VL_API_PROXY_ARP_INTFC_ENABLE_DISABLE + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "proxy_arp_intfc_enable_disable_reply_e8d4e804",
                                VL_API_PROXY_ARP_INTFC_ENABLE_DISABLE_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "proxy_arp_intfc_dump_51077d14",
                                VL_API_PROXY_ARP_INTFC_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "proxy_arp_intfc_details_f6458e5f",
                                VL_API_PROXY_ARP_INTFC_DETAILS + msg_id_base);
   vl_msg_api_set_handlers(VL_API_PROXY_ARP_ADD_DEL + msg_id_base, "proxy_arp_add_del",
                           vl_api_proxy_arp_add_del_t_handler, vl_noop_handler,
                           vl_api_proxy_arp_add_del_t_endian, vl_api_proxy_arp_add_del_t_print,
                           sizeof(vl_api_proxy_arp_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_PROXY_ARP_DUMP + msg_id_base, "proxy_arp_dump",
                           vl_api_proxy_arp_dump_t_handler, vl_noop_handler,
                           vl_api_proxy_arp_dump_t_endian, vl_api_proxy_arp_dump_t_print,
                           sizeof(vl_api_proxy_arp_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_PROXY_ARP_INTFC_ENABLE_DISABLE + msg_id_base, "proxy_arp_intfc_enable_disable",
                           vl_api_proxy_arp_intfc_enable_disable_t_handler, vl_noop_handler,
                           vl_api_proxy_arp_intfc_enable_disable_t_endian, vl_api_proxy_arp_intfc_enable_disable_t_print,
                           sizeof(vl_api_proxy_arp_intfc_enable_disable_t), 1);
   vl_msg_api_set_handlers(VL_API_PROXY_ARP_INTFC_DUMP + msg_id_base, "proxy_arp_intfc_dump",
                           vl_api_proxy_arp_intfc_dump_t_handler, vl_noop_handler,
                           vl_api_proxy_arp_intfc_dump_t_endian, vl_api_proxy_arp_intfc_dump_t_print,
                           sizeof(vl_api_proxy_arp_intfc_dump_t), 1);
   return msg_id_base;
}
