#define vl_endianfun		/* define message structures */
#include "ip6_nd.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "ip6_nd.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("ip6_nd_ac628462", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "sw_interface_ip6nd_ra_config_3eb00b1c",
                                VL_API_SW_INTERFACE_IP6ND_RA_CONFIG + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "sw_interface_ip6nd_ra_config_reply_e8d4e804",
                                VL_API_SW_INTERFACE_IP6ND_RA_CONFIG_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "sw_interface_ip6nd_ra_prefix_e098785f",
                                VL_API_SW_INTERFACE_IP6ND_RA_PREFIX + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "sw_interface_ip6nd_ra_prefix_reply_e8d4e804",
                                VL_API_SW_INTERFACE_IP6ND_RA_PREFIX_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ip6nd_proxy_add_del_3fdf6659",
                                VL_API_IP6ND_PROXY_ADD_DEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ip6nd_proxy_add_del_reply_e8d4e804",
                                VL_API_IP6ND_PROXY_ADD_DEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ip6nd_proxy_details_d35be8ff",
                                VL_API_IP6ND_PROXY_DETAILS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ip6nd_proxy_dump_51077d14",
                                VL_API_IP6ND_PROXY_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ip6nd_send_router_solicitation_e5de609c",
                                VL_API_IP6ND_SEND_ROUTER_SOLICITATION + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ip6nd_send_router_solicitation_reply_e8d4e804",
                                VL_API_IP6ND_SEND_ROUTER_SOLICITATION_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "want_ip6_ra_events_3ec6d6c2",
                                VL_API_WANT_IP6_RA_EVENTS + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "want_ip6_ra_events_reply_e8d4e804",
                                VL_API_WANT_IP6_RA_EVENTS_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ip6_ra_event_47e8cfbe",
                                VL_API_IP6_RA_EVENT + msg_id_base);
   vl_msg_api_set_handlers(VL_API_WANT_IP6_RA_EVENTS + msg_id_base, "want_ip6_ra_events",
                           vl_api_want_ip6_ra_events_t_handler, vl_noop_handler,
                           vl_api_want_ip6_ra_events_t_endian, vl_api_want_ip6_ra_events_t_print,
                           sizeof(vl_api_want_ip6_ra_events_t), 1);
   vl_msg_api_set_handlers(VL_API_SW_INTERFACE_IP6ND_RA_CONFIG + msg_id_base, "sw_interface_ip6nd_ra_config",
                           vl_api_sw_interface_ip6nd_ra_config_t_handler, vl_noop_handler,
                           vl_api_sw_interface_ip6nd_ra_config_t_endian, vl_api_sw_interface_ip6nd_ra_config_t_print,
                           sizeof(vl_api_sw_interface_ip6nd_ra_config_t), 1);
   vl_msg_api_set_handlers(VL_API_SW_INTERFACE_IP6ND_RA_PREFIX + msg_id_base, "sw_interface_ip6nd_ra_prefix",
                           vl_api_sw_interface_ip6nd_ra_prefix_t_handler, vl_noop_handler,
                           vl_api_sw_interface_ip6nd_ra_prefix_t_endian, vl_api_sw_interface_ip6nd_ra_prefix_t_print,
                           sizeof(vl_api_sw_interface_ip6nd_ra_prefix_t), 1);
   vl_msg_api_set_handlers(VL_API_IP6ND_PROXY_ADD_DEL + msg_id_base, "ip6nd_proxy_add_del",
                           vl_api_ip6nd_proxy_add_del_t_handler, vl_noop_handler,
                           vl_api_ip6nd_proxy_add_del_t_endian, vl_api_ip6nd_proxy_add_del_t_print,
                           sizeof(vl_api_ip6nd_proxy_add_del_t), 1);
   vl_msg_api_set_handlers(VL_API_IP6ND_PROXY_DUMP + msg_id_base, "ip6nd_proxy_dump",
                           vl_api_ip6nd_proxy_dump_t_handler, vl_noop_handler,
                           vl_api_ip6nd_proxy_dump_t_endian, vl_api_ip6nd_proxy_dump_t_print,
                           sizeof(vl_api_ip6nd_proxy_dump_t), 1);
   vl_msg_api_set_handlers(VL_API_IP6ND_SEND_ROUTER_SOLICITATION + msg_id_base, "ip6nd_send_router_solicitation",
                           vl_api_ip6nd_send_router_solicitation_t_handler, vl_noop_handler,
                           vl_api_ip6nd_send_router_solicitation_t_endian, vl_api_ip6nd_send_router_solicitation_t_print,
                           sizeof(vl_api_ip6nd_send_router_solicitation_t), 1);
   return msg_id_base;
}
