#define vl_endianfun		/* define message structures */
#include "ipip.api.h"
#undef vl_endianfun

/* instantiate all the print functions we know about */
#define vl_print(handle, ...) vlib_cli_output (handle, __VA_ARGS__)
#define vl_printfun
#include "ipip.api.h"
#undef vl_printfun

static u16
setup_message_id_table (void) {
   api_main_t *am = my_api_main;
   u16 msg_id_base = vl_msg_api_get_msg_ids ("ipip_f1d7a878", VL_MSG_FIRST_AVAILABLE);
   vl_msg_api_add_msg_name_crc (am, "ipip_add_tunnel_ef93caab",
                                VL_API_IPIP_ADD_TUNNEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ipip_add_tunnel_reply_5383d31f",
                                VL_API_IPIP_ADD_TUNNEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ipip_del_tunnel_f9e6675e",
                                VL_API_IPIP_DEL_TUNNEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ipip_del_tunnel_reply_e8d4e804",
                                VL_API_IPIP_DEL_TUNNEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ipip_6rd_add_tunnel_56e93cc0",
                                VL_API_IPIP_6RD_ADD_TUNNEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ipip_6rd_add_tunnel_reply_5383d31f",
                                VL_API_IPIP_6RD_ADD_TUNNEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ipip_6rd_del_tunnel_f9e6675e",
                                VL_API_IPIP_6RD_DEL_TUNNEL + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ipip_6rd_del_tunnel_reply_e8d4e804",
                                VL_API_IPIP_6RD_DEL_TUNNEL_REPLY + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ipip_tunnel_dump_f9e6675e",
                                VL_API_IPIP_TUNNEL_DUMP + msg_id_base);
   vl_msg_api_add_msg_name_crc (am, "ipip_tunnel_details_7f7b5b85",
                                VL_API_IPIP_TUNNEL_DETAILS + msg_id_base);
   vl_msg_api_set_handlers(VL_API_IPIP_ADD_TUNNEL + msg_id_base, "ipip_add_tunnel",
                           vl_api_ipip_add_tunnel_t_handler, vl_noop_handler,
                           vl_api_ipip_add_tunnel_t_endian, vl_api_ipip_add_tunnel_t_print,
                           sizeof(vl_api_ipip_add_tunnel_t), 1);
   vl_msg_api_set_handlers(VL_API_IPIP_DEL_TUNNEL + msg_id_base, "ipip_del_tunnel",
                           vl_api_ipip_del_tunnel_t_handler, vl_noop_handler,
                           vl_api_ipip_del_tunnel_t_endian, vl_api_ipip_del_tunnel_t_print,
                           sizeof(vl_api_ipip_del_tunnel_t), 1);
   vl_msg_api_set_handlers(VL_API_IPIP_6RD_ADD_TUNNEL + msg_id_base, "ipip_6rd_add_tunnel",
                           vl_api_ipip_6rd_add_tunnel_t_handler, vl_noop_handler,
                           vl_api_ipip_6rd_add_tunnel_t_endian, vl_api_ipip_6rd_add_tunnel_t_print,
                           sizeof(vl_api_ipip_6rd_add_tunnel_t), 1);
   vl_msg_api_set_handlers(VL_API_IPIP_6RD_DEL_TUNNEL + msg_id_base, "ipip_6rd_del_tunnel",
                           vl_api_ipip_6rd_del_tunnel_t_handler, vl_noop_handler,
                           vl_api_ipip_6rd_del_tunnel_t_endian, vl_api_ipip_6rd_del_tunnel_t_print,
                           sizeof(vl_api_ipip_6rd_del_tunnel_t), 1);
   vl_msg_api_set_handlers(VL_API_IPIP_TUNNEL_DUMP + msg_id_base, "ipip_tunnel_dump",
                           vl_api_ipip_tunnel_dump_t_handler, vl_noop_handler,
                           vl_api_ipip_tunnel_dump_t_endian, vl_api_ipip_tunnel_dump_t_print,
                           sizeof(vl_api_ipip_tunnel_dump_t), 1);
   return msg_id_base;
}
