#ifndef included_one_api_types_h
#define included_one_api_types_h
typedef struct __attribute__ ((packed)) _vl_api_one_local_locator {
    u32 sw_if_index;
    u8 priority;
    u8 weight;
} vl_api_one_local_locator_t;
typedef struct __attribute__ ((packed)) _vl_api_one_remote_locator {
    u8 is_ip4;
    u8 priority;
    u8 weight;
    u8 addr[16];
} vl_api_one_remote_locator_t;
typedef struct __attribute__ ((packed)) _vl_api_one_l2_arp_entry {
    u8 mac[6];
    u32 ip4;
} vl_api_one_l2_arp_entry_t;
typedef struct __attribute__ ((packed)) _vl_api_one_ndp_entry {
    u8 mac[6];
    u8 ip6[16];
} vl_api_one_ndp_entry_t;
typedef struct __attribute__ ((packed)) _vl_api_one_adjacency {
    u8 eid_type;
    u8 reid[16];
    u8 leid[16];
    u8 reid_prefix_len;
    u8 leid_prefix_len;
} vl_api_one_adjacency_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_locator_set {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 locator_set_name[64];
    u32 locator_num;
    vl_api_one_local_locator_t locators[0];
} vl_api_one_add_del_locator_set_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_locator_set_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 ls_index;
} vl_api_one_add_del_locator_set_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_locator {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 locator_set_name[64];
    u32 sw_if_index;
    u8 priority;
    u8 weight;
} vl_api_one_add_del_locator_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_locator_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_add_del_locator_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_local_eid {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 eid_type;
    u8 eid[16];
    u8 prefix_len;
    u8 locator_set_name[64];
    u32 vni;
    u16 key_id;
    u8 key[64];
} vl_api_one_add_del_local_eid_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_local_eid_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_add_del_local_eid_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_register_set_ttl {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 ttl;
} vl_api_one_map_register_set_ttl_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_register_set_ttl_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_map_register_set_ttl_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_map_register_ttl {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_show_one_map_register_ttl_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_map_register_ttl_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 ttl;
} vl_api_show_one_map_register_ttl_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_map_server {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 is_ipv6;
    u8 ip_address[16];
} vl_api_one_add_del_map_server_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_map_server_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_add_del_map_server_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_map_resolver {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 is_ipv6;
    u8 ip_address[16];
} vl_api_one_add_del_map_resolver_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_map_resolver_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_add_del_map_resolver_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_en;
} vl_api_one_enable_disable_t;
typedef struct __attribute__ ((packed)) _vl_api_one_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_enable_disable_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_nsh_set_locator_set {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 ls_name[64];
} vl_api_one_nsh_set_locator_set_t;
typedef struct __attribute__ ((packed)) _vl_api_one_nsh_set_locator_set_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_nsh_set_locator_set_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_pitr_set_locator_set {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 ls_name[64];
} vl_api_one_pitr_set_locator_set_t;
typedef struct __attribute__ ((packed)) _vl_api_one_pitr_set_locator_set_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_pitr_set_locator_set_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_use_petr {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_ip4;
    u8 address[16];
    u8 is_add;
} vl_api_one_use_petr_t;
typedef struct __attribute__ ((packed)) _vl_api_one_use_petr_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_use_petr_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_use_petr {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_show_one_use_petr_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_use_petr_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 status;
    u8 is_ip4;
    u8 address[16];
} vl_api_show_one_use_petr_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_rloc_probe_state {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_show_one_rloc_probe_state_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_rloc_probe_state_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 is_enabled;
} vl_api_show_one_rloc_probe_state_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_rloc_probe_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_enabled;
} vl_api_one_rloc_probe_enable_disable_t;
typedef struct __attribute__ ((packed)) _vl_api_one_rloc_probe_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_rloc_probe_enable_disable_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_register_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_enabled;
} vl_api_one_map_register_enable_disable_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_register_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_map_register_enable_disable_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_map_register_state {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_show_one_map_register_state_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_map_register_state_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 is_enabled;
} vl_api_show_one_map_register_state_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_request_mode {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 mode;
} vl_api_one_map_request_mode_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_request_mode_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_map_request_mode_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_map_request_mode {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_show_one_map_request_mode_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_map_request_mode_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 mode;
} vl_api_show_one_map_request_mode_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_remote_mapping {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 is_src_dst;
    u8 del_all;
    u32 vni;
    u8 action;
    u8 eid_type;
    u8 eid[16];
    u8 eid_len;
    u8 seid[16];
    u8 seid_len;
    u32 rloc_num;
    vl_api_one_remote_locator_t rlocs[0];
} vl_api_one_add_del_remote_mapping_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_remote_mapping_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_add_del_remote_mapping_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_l2_arp_entry {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 mac[6];
    u32 bd;
    u32 ip4;
} vl_api_one_add_del_l2_arp_entry_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_l2_arp_entry_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_add_del_l2_arp_entry_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_l2_arp_entries_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 bd;
} vl_api_one_l2_arp_entries_get_t;
typedef struct __attribute__ ((packed)) _vl_api_one_l2_arp_entries_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 count;
    vl_api_one_l2_arp_entry_t entries[0];
} vl_api_one_l2_arp_entries_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_ndp_entry {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 mac[6];
    u32 bd;
    u8 ip6[16];
} vl_api_one_add_del_ndp_entry_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_ndp_entry_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_add_del_ndp_entry_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_ndp_entries_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 bd;
} vl_api_one_ndp_entries_get_t;
typedef struct __attribute__ ((packed)) _vl_api_one_ndp_entries_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 count;
    vl_api_one_ndp_entry_t entries[0];
} vl_api_one_ndp_entries_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_set_transport_protocol {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 protocol;
} vl_api_one_set_transport_protocol_t;
typedef struct __attribute__ ((packed)) _vl_api_one_set_transport_protocol_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_set_transport_protocol_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_get_transport_protocol {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_get_transport_protocol_t;
typedef struct __attribute__ ((packed)) _vl_api_one_get_transport_protocol_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 protocol;
} vl_api_one_get_transport_protocol_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_ndp_bd_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_ndp_bd_get_t;
typedef struct __attribute__ ((packed)) _vl_api_one_ndp_bd_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 count;
    u32 bridge_domains[0];
} vl_api_one_ndp_bd_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_l2_arp_bd_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_l2_arp_bd_get_t;
typedef struct __attribute__ ((packed)) _vl_api_one_l2_arp_bd_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 count;
    u32 bridge_domains[0];
} vl_api_one_l2_arp_bd_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_adjacency {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u32 vni;
    u8 eid_type;
    u8 reid[16];
    u8 leid[16];
    u8 reid_len;
    u8 leid_len;
} vl_api_one_add_del_adjacency_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_adjacency_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_add_del_adjacency_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_map_request_itr_rlocs {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 locator_set_name[64];
} vl_api_one_add_del_map_request_itr_rlocs_t;
typedef struct __attribute__ ((packed)) _vl_api_one_add_del_map_request_itr_rlocs_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_add_del_map_request_itr_rlocs_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_eid_table_add_del_map {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u32 vni;
    u32 dp_table;
    u8 is_l2;
} vl_api_one_eid_table_add_del_map_t;
typedef struct __attribute__ ((packed)) _vl_api_one_eid_table_add_del_map_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_eid_table_add_del_map_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_locator_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 ls_index;
    u8 ls_name[64];
    u8 is_index_set;
} vl_api_one_locator_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_one_locator_details {
    u16 _vl_msg_id;
    u32 context;
    u8 local;
    u32 sw_if_index;
    u8 is_ipv6;
    u8 ip_address[16];
    u8 priority;
    u8 weight;
} vl_api_one_locator_details_t;
typedef struct __attribute__ ((packed)) _vl_api_one_locator_set_details {
    u16 _vl_msg_id;
    u32 context;
    u32 ls_index;
    u8 ls_name[64];
} vl_api_one_locator_set_details_t;
typedef struct __attribute__ ((packed)) _vl_api_one_locator_set_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 filter;
} vl_api_one_locator_set_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_one_eid_table_details {
    u16 _vl_msg_id;
    u32 context;
    u32 locator_set_index;
    u8 action;
    u8 is_local;
    u8 eid_type;
    u8 is_src_dst;
    u32 vni;
    u8 eid[16];
    u8 eid_prefix_len;
    u8 seid[16];
    u8 seid_prefix_len;
    u32 ttl;
    u8 authoritative;
    u16 key_id;
    u8 key[64];
} vl_api_one_eid_table_details_t;
typedef struct __attribute__ ((packed)) _vl_api_one_eid_table_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 eid_set;
    u8 prefix_length;
    u32 vni;
    u8 eid_type;
    u8 eid[16];
    u8 filter;
} vl_api_one_eid_table_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_one_adjacencies_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 count;
    vl_api_one_adjacency_t adjacencies[0];
} vl_api_one_adjacencies_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_adjacencies_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 vni;
} vl_api_one_adjacencies_get_t;
typedef struct __attribute__ ((packed)) _vl_api_one_eid_table_map_details {
    u16 _vl_msg_id;
    u32 context;
    u32 vni;
    u32 dp_table;
} vl_api_one_eid_table_map_details_t;
typedef struct __attribute__ ((packed)) _vl_api_one_eid_table_map_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_l2;
} vl_api_one_eid_table_map_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_one_eid_table_vni_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_eid_table_vni_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_one_eid_table_vni_details {
    u16 _vl_msg_id;
    u32 context;
    u32 vni;
} vl_api_one_eid_table_vni_details_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_resolver_details {
    u16 _vl_msg_id;
    u32 context;
    u8 is_ipv6;
    u8 ip_address[16];
} vl_api_one_map_resolver_details_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_resolver_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_map_resolver_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_server_details {
    u16 _vl_msg_id;
    u32 context;
    u8 is_ipv6;
    u8 ip_address[16];
} vl_api_one_map_server_details_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_server_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_map_server_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_status {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_show_one_status_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_status_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 feature_status;
    u8 gpe_status;
} vl_api_show_one_status_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_get_map_request_itr_rlocs {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_get_map_request_itr_rlocs_t;
typedef struct __attribute__ ((packed)) _vl_api_one_get_map_request_itr_rlocs_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 locator_set_name[64];
} vl_api_one_get_map_request_itr_rlocs_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_nsh_mapping {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_show_one_nsh_mapping_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_nsh_mapping_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 is_set;
    u8 locator_set_name[64];
} vl_api_show_one_nsh_mapping_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_pitr {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_show_one_pitr_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_pitr_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 status;
    u8 locator_set_name[64];
} vl_api_show_one_pitr_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_stats_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_stats_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_one_stats_details {
    u16 _vl_msg_id;
    u32 context;
    u32 vni;
    u8 eid_type;
    u8 deid[16];
    u8 seid[16];
    u8 deid_pref_len;
    u8 seid_pref_len;
    u8 is_ip4;
    u8 rloc[16];
    u8 lloc[16];
    u32 pkt_count;
    u32 bytes;
} vl_api_one_stats_details_t;
typedef struct __attribute__ ((packed)) _vl_api_one_stats_flush {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_stats_flush_t;
typedef struct __attribute__ ((packed)) _vl_api_one_stats_flush_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_stats_flush_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_stats_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_en;
} vl_api_one_stats_enable_disable_t;
typedef struct __attribute__ ((packed)) _vl_api_one_stats_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_stats_enable_disable_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_stats_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_show_one_stats_enable_disable_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_stats_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 is_en;
} vl_api_show_one_stats_enable_disable_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_register_fallback_threshold {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 value;
} vl_api_one_map_register_fallback_threshold_t;
typedef struct __attribute__ ((packed)) _vl_api_one_map_register_fallback_threshold_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_map_register_fallback_threshold_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_map_register_fallback_threshold {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_show_one_map_register_fallback_threshold_t;
typedef struct __attribute__ ((packed)) _vl_api_show_one_map_register_fallback_threshold_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 value;
} vl_api_show_one_map_register_fallback_threshold_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_enable_disable_xtr_mode {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_en;
} vl_api_one_enable_disable_xtr_mode_t;
typedef struct __attribute__ ((packed)) _vl_api_one_enable_disable_xtr_mode_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_enable_disable_xtr_mode_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_show_xtr_mode {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_show_xtr_mode_t;
typedef struct __attribute__ ((packed)) _vl_api_one_show_xtr_mode_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 is_en;
} vl_api_one_show_xtr_mode_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_enable_disable_petr_mode {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_en;
} vl_api_one_enable_disable_petr_mode_t;
typedef struct __attribute__ ((packed)) _vl_api_one_enable_disable_petr_mode_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_enable_disable_petr_mode_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_show_petr_mode {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_show_petr_mode_t;
typedef struct __attribute__ ((packed)) _vl_api_one_show_petr_mode_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 is_en;
} vl_api_one_show_petr_mode_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_enable_disable_pitr_mode {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_en;
} vl_api_one_enable_disable_pitr_mode_t;
typedef struct __attribute__ ((packed)) _vl_api_one_enable_disable_pitr_mode_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_one_enable_disable_pitr_mode_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_one_show_pitr_mode {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_one_show_pitr_mode_t;
typedef struct __attribute__ ((packed)) _vl_api_one_show_pitr_mode_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 is_en;
} vl_api_one_show_pitr_mode_reply_t;
#define VL_API_ONE_ADD_DEL_LOCATOR_SET_CRC "one_add_del_locator_set_2e73b050"
#define VL_API_ONE_ADD_DEL_LOCATOR_SET_REPLY_CRC "one_add_del_locator_set_reply_b6666db4"
#define VL_API_ONE_ADD_DEL_LOCATOR_CRC "one_add_del_locator_006a4240"
#define VL_API_ONE_ADD_DEL_LOCATOR_REPLY_CRC "one_add_del_locator_reply_e8d4e804"
#define VL_API_ONE_ADD_DEL_LOCAL_EID_CRC "one_add_del_local_eid_e6d00717"
#define VL_API_ONE_ADD_DEL_LOCAL_EID_REPLY_CRC "one_add_del_local_eid_reply_e8d4e804"
#define VL_API_ONE_MAP_REGISTER_SET_TTL_CRC "one_map_register_set_ttl_dd59f1f3"
#define VL_API_ONE_MAP_REGISTER_SET_TTL_REPLY_CRC "one_map_register_set_ttl_reply_e8d4e804"
#define VL_API_SHOW_ONE_MAP_REGISTER_TTL_CRC "show_one_map_register_ttl_51077d14"
#define VL_API_SHOW_ONE_MAP_REGISTER_TTL_REPLY_CRC "show_one_map_register_ttl_reply_fa83dd66"
#define VL_API_ONE_ADD_DEL_MAP_SERVER_CRC "one_add_del_map_server_0ebcd37d"
#define VL_API_ONE_ADD_DEL_MAP_SERVER_REPLY_CRC "one_add_del_map_server_reply_e8d4e804"
#define VL_API_ONE_ADD_DEL_MAP_RESOLVER_CRC "one_add_del_map_resolver_0ebcd37d"
#define VL_API_ONE_ADD_DEL_MAP_RESOLVER_REPLY_CRC "one_add_del_map_resolver_reply_e8d4e804"
#define VL_API_ONE_ENABLE_DISABLE_CRC "one_enable_disable_eb0e943b"
#define VL_API_ONE_ENABLE_DISABLE_REPLY_CRC "one_enable_disable_reply_e8d4e804"
#define VL_API_ONE_NSH_SET_LOCATOR_SET_CRC "one_nsh_set_locator_set_7aa022dd"
#define VL_API_ONE_NSH_SET_LOCATOR_SET_REPLY_CRC "one_nsh_set_locator_set_reply_e8d4e804"
#define VL_API_ONE_PITR_SET_LOCATOR_SET_CRC "one_pitr_set_locator_set_7aa022dd"
#define VL_API_ONE_PITR_SET_LOCATOR_SET_REPLY_CRC "one_pitr_set_locator_set_reply_e8d4e804"
#define VL_API_ONE_USE_PETR_CRC "one_use_petr_6910787d"
#define VL_API_ONE_USE_PETR_REPLY_CRC "one_use_petr_reply_e8d4e804"
#define VL_API_SHOW_ONE_USE_PETR_CRC "show_one_use_petr_51077d14"
#define VL_API_SHOW_ONE_USE_PETR_REPLY_CRC "show_one_use_petr_reply_1eb21916"
#define VL_API_SHOW_ONE_RLOC_PROBE_STATE_CRC "show_one_rloc_probe_state_51077d14"
#define VL_API_SHOW_ONE_RLOC_PROBE_STATE_REPLY_CRC "show_one_rloc_probe_state_reply_14304fbc"
#define VL_API_ONE_RLOC_PROBE_ENABLE_DISABLE_CRC "one_rloc_probe_enable_disable_294103d1"
#define VL_API_ONE_RLOC_PROBE_ENABLE_DISABLE_REPLY_CRC "one_rloc_probe_enable_disable_reply_e8d4e804"
#define VL_API_ONE_MAP_REGISTER_ENABLE_DISABLE_CRC "one_map_register_enable_disable_294103d1"
#define VL_API_ONE_MAP_REGISTER_ENABLE_DISABLE_REPLY_CRC "one_map_register_enable_disable_reply_e8d4e804"
#define VL_API_SHOW_ONE_MAP_REGISTER_STATE_CRC "show_one_map_register_state_51077d14"
#define VL_API_SHOW_ONE_MAP_REGISTER_STATE_REPLY_CRC "show_one_map_register_state_reply_14304fbc"
#define VL_API_ONE_MAP_REQUEST_MODE_CRC "one_map_request_mode_f3f93ce9"
#define VL_API_ONE_MAP_REQUEST_MODE_REPLY_CRC "one_map_request_mode_reply_e8d4e804"
#define VL_API_SHOW_ONE_MAP_REQUEST_MODE_CRC "show_one_map_request_mode_51077d14"
#define VL_API_SHOW_ONE_MAP_REQUEST_MODE_REPLY_CRC "show_one_map_request_mode_reply_d423107c"
#define VL_API_ONE_ADD_DEL_REMOTE_MAPPING_CRC "one_add_del_remote_mapping_0b2010ec"
#define VL_API_ONE_ADD_DEL_REMOTE_MAPPING_REPLY_CRC "one_add_del_remote_mapping_reply_e8d4e804"
#define VL_API_ONE_ADD_DEL_L2_ARP_ENTRY_CRC "one_add_del_l2_arp_entry_a95cc2d7"
#define VL_API_ONE_ADD_DEL_L2_ARP_ENTRY_REPLY_CRC "one_add_del_l2_arp_entry_reply_e8d4e804"
#define VL_API_ONE_L2_ARP_ENTRIES_GET_CRC "one_l2_arp_entries_get_4d418cf4"
#define VL_API_ONE_L2_ARP_ENTRIES_GET_REPLY_CRC "one_l2_arp_entries_get_reply_88e54ded"
#define VL_API_ONE_ADD_DEL_NDP_ENTRY_CRC "one_add_del_ndp_entry_e9468fe3"
#define VL_API_ONE_ADD_DEL_NDP_ENTRY_REPLY_CRC "one_add_del_ndp_entry_reply_e8d4e804"
#define VL_API_ONE_NDP_ENTRIES_GET_CRC "one_ndp_entries_get_4d418cf4"
#define VL_API_ONE_NDP_ENTRIES_GET_REPLY_CRC "one_ndp_entries_get_reply_d0822f37"
#define VL_API_ONE_SET_TRANSPORT_PROTOCOL_CRC "one_set_transport_protocol_07b6b85f"
#define VL_API_ONE_SET_TRANSPORT_PROTOCOL_REPLY_CRC "one_set_transport_protocol_reply_e8d4e804"
#define VL_API_ONE_GET_TRANSPORT_PROTOCOL_CRC "one_get_transport_protocol_51077d14"
#define VL_API_ONE_GET_TRANSPORT_PROTOCOL_REPLY_CRC "one_get_transport_protocol_reply_62a28eb3"
#define VL_API_ONE_NDP_BD_GET_CRC "one_ndp_bd_get_51077d14"
#define VL_API_ONE_NDP_BD_GET_REPLY_CRC "one_ndp_bd_get_reply_221ac888"
#define VL_API_ONE_L2_ARP_BD_GET_CRC "one_l2_arp_bd_get_51077d14"
#define VL_API_ONE_L2_ARP_BD_GET_REPLY_CRC "one_l2_arp_bd_get_reply_221ac888"
#define VL_API_ONE_ADD_DEL_ADJACENCY_CRC "one_add_del_adjacency_f047390d"
#define VL_API_ONE_ADD_DEL_ADJACENCY_REPLY_CRC "one_add_del_adjacency_reply_e8d4e804"
#define VL_API_ONE_ADD_DEL_MAP_REQUEST_ITR_RLOCS_CRC "one_add_del_map_request_itr_rlocs_c7c6cb2f"
#define VL_API_ONE_ADD_DEL_MAP_REQUEST_ITR_RLOCS_REPLY_CRC "one_add_del_map_request_itr_rlocs_reply_e8d4e804"
#define VL_API_ONE_EID_TABLE_ADD_DEL_MAP_CRC "one_eid_table_add_del_map_59e9975e"
#define VL_API_ONE_EID_TABLE_ADD_DEL_MAP_REPLY_CRC "one_eid_table_add_del_map_reply_e8d4e804"
#define VL_API_ONE_LOCATOR_DUMP_CRC "one_locator_dump_f27d5050"
#define VL_API_ONE_LOCATOR_DETAILS_CRC "one_locator_details_b3988a30"
#define VL_API_ONE_LOCATOR_SET_DETAILS_CRC "one_locator_set_details_6b846882"
#define VL_API_ONE_LOCATOR_SET_DUMP_CRC "one_locator_set_dump_c79e8ab0"
#define VL_API_ONE_EID_TABLE_DETAILS_CRC "one_eid_table_details_dcd9f414"
#define VL_API_ONE_EID_TABLE_DUMP_CRC "one_eid_table_dump_e0df64da"
#define VL_API_ONE_ADJACENCIES_GET_REPLY_CRC "one_adjacencies_get_reply_60a3c592"
#define VL_API_ONE_ADJACENCIES_GET_CRC "one_adjacencies_get_8d1f2fe9"
#define VL_API_ONE_EID_TABLE_MAP_DETAILS_CRC "one_eid_table_map_details_0b6859e2"
#define VL_API_ONE_EID_TABLE_MAP_DUMP_CRC "one_eid_table_map_dump_67c54650"
#define VL_API_ONE_EID_TABLE_VNI_DUMP_CRC "one_eid_table_vni_dump_51077d14"
#define VL_API_ONE_EID_TABLE_VNI_DETAILS_CRC "one_eid_table_vni_details_64abc01e"
#define VL_API_ONE_MAP_RESOLVER_DETAILS_CRC "one_map_resolver_details_60a5f5ca"
#define VL_API_ONE_MAP_RESOLVER_DUMP_CRC "one_map_resolver_dump_51077d14"
#define VL_API_ONE_MAP_SERVER_DETAILS_CRC "one_map_server_details_60a5f5ca"
#define VL_API_ONE_MAP_SERVER_DUMP_CRC "one_map_server_dump_51077d14"
#define VL_API_SHOW_ONE_STATUS_CRC "show_one_status_51077d14"
#define VL_API_SHOW_ONE_STATUS_REPLY_CRC "show_one_status_reply_ddcf48ef"
#define VL_API_ONE_GET_MAP_REQUEST_ITR_RLOCS_CRC "one_get_map_request_itr_rlocs_51077d14"
#define VL_API_ONE_GET_MAP_REQUEST_ITR_RLOCS_REPLY_CRC "one_get_map_request_itr_rlocs_reply_9f56f6f7"
#define VL_API_SHOW_ONE_NSH_MAPPING_CRC "show_one_nsh_mapping_51077d14"
#define VL_API_SHOW_ONE_NSH_MAPPING_REPLY_CRC "show_one_nsh_mapping_reply_f2ff364e"
#define VL_API_SHOW_ONE_PITR_CRC "show_one_pitr_51077d14"
#define VL_API_SHOW_ONE_PITR_REPLY_CRC "show_one_pitr_reply_dca512cc"
#define VL_API_ONE_STATS_DUMP_CRC "one_stats_dump_51077d14"
#define VL_API_ONE_STATS_DETAILS_CRC "one_stats_details_e1a34a05"
#define VL_API_ONE_STATS_FLUSH_CRC "one_stats_flush_51077d14"
#define VL_API_ONE_STATS_FLUSH_REPLY_CRC "one_stats_flush_reply_e8d4e804"
#define VL_API_ONE_STATS_ENABLE_DISABLE_CRC "one_stats_enable_disable_eb0e943b"
#define VL_API_ONE_STATS_ENABLE_DISABLE_REPLY_CRC "one_stats_enable_disable_reply_e8d4e804"
#define VL_API_SHOW_ONE_STATS_ENABLE_DISABLE_CRC "show_one_stats_enable_disable_51077d14"
#define VL_API_SHOW_ONE_STATS_ENABLE_DISABLE_REPLY_CRC "show_one_stats_enable_disable_reply_6b4c29dc"
#define VL_API_ONE_MAP_REGISTER_FALLBACK_THRESHOLD_CRC "one_map_register_fallback_threshold_f7d4a475"
#define VL_API_ONE_MAP_REGISTER_FALLBACK_THRESHOLD_REPLY_CRC "one_map_register_fallback_threshold_reply_e8d4e804"
#define VL_API_SHOW_ONE_MAP_REGISTER_FALLBACK_THRESHOLD_CRC "show_one_map_register_fallback_threshold_51077d14"
#define VL_API_SHOW_ONE_MAP_REGISTER_FALLBACK_THRESHOLD_REPLY_CRC "show_one_map_register_fallback_threshold_reply_c93a9113"
#define VL_API_ONE_ENABLE_DISABLE_XTR_MODE_CRC "one_enable_disable_xtr_mode_eb0e943b"
#define VL_API_ONE_ENABLE_DISABLE_XTR_MODE_REPLY_CRC "one_enable_disable_xtr_mode_reply_e8d4e804"
#define VL_API_ONE_SHOW_XTR_MODE_CRC "one_show_xtr_mode_51077d14"
#define VL_API_ONE_SHOW_XTR_MODE_REPLY_CRC "one_show_xtr_mode_reply_6b4c29dc"
#define VL_API_ONE_ENABLE_DISABLE_PETR_MODE_CRC "one_enable_disable_petr_mode_eb0e943b"
#define VL_API_ONE_ENABLE_DISABLE_PETR_MODE_REPLY_CRC "one_enable_disable_petr_mode_reply_e8d4e804"
#define VL_API_ONE_SHOW_PETR_MODE_CRC "one_show_petr_mode_51077d14"
#define VL_API_ONE_SHOW_PETR_MODE_REPLY_CRC "one_show_petr_mode_reply_6b4c29dc"
#define VL_API_ONE_ENABLE_DISABLE_PITR_MODE_CRC "one_enable_disable_pitr_mode_eb0e943b"
#define VL_API_ONE_ENABLE_DISABLE_PITR_MODE_REPLY_CRC "one_enable_disable_pitr_mode_reply_e8d4e804"
#define VL_API_ONE_SHOW_PITR_MODE_CRC "one_show_pitr_mode_51077d14"
#define VL_API_ONE_SHOW_PITR_MODE_REPLY_CRC "one_show_pitr_mode_reply_6b4c29dc"

#endif
