#ifndef included_lisp_gpe_api_types_h
#define included_lisp_gpe_api_types_h
typedef struct __attribute__ ((packed)) _vl_api_gpe_locator {
    u8 is_ip4;
    u8 weight;
    u8 addr[16];
} vl_api_gpe_locator_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_fwd_entry {
    u32 fwd_entry_index;
    u32 dp_table;
    u8 eid_type;
    u8 leid_prefix_len;
    u8 reid_prefix_len;
    u8 leid[16];
    u8 reid[16];
    u32 vni;
    u8 action;
} vl_api_gpe_fwd_entry_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_native_fwd_rpath {
    u32 fib_index;
    u32 nh_sw_if_index;
    u8 is_ip4;
    u8 nh_addr[16];
} vl_api_gpe_native_fwd_rpath_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_add_del_fwd_entry {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 eid_type;
    u8 rmt_eid[16];
    u8 lcl_eid[16];
    u8 rmt_len;
    u8 lcl_len;
    u32 vni;
    u32 dp_table;
    u8 action;
    u32 loc_num;
    vl_api_gpe_locator_t locs[0];
} vl_api_gpe_add_del_fwd_entry_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_add_del_fwd_entry_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 fwd_entry_index;
} vl_api_gpe_add_del_fwd_entry_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_en;
} vl_api_gpe_enable_disable_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_gpe_enable_disable_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_add_del_iface {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u8 is_l2;
    u32 dp_table;
    u32 vni;
} vl_api_gpe_add_del_iface_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_add_del_iface_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_gpe_add_del_iface_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_fwd_entry_vnis_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_gpe_fwd_entry_vnis_get_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_fwd_entry_vnis_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 count;
    u32 vnis[0];
} vl_api_gpe_fwd_entry_vnis_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_fwd_entries_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 vni;
} vl_api_gpe_fwd_entries_get_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_fwd_entries_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 count;
    vl_api_gpe_fwd_entry_t entries[0];
} vl_api_gpe_fwd_entries_get_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_fwd_entry_path_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 fwd_entry_index;
} vl_api_gpe_fwd_entry_path_dump_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_fwd_entry_path_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_gpe_locator_t lcl_loc;
    vl_api_gpe_locator_t rmt_loc;
} vl_api_gpe_fwd_entry_path_details_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_set_encap_mode {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 mode;
} vl_api_gpe_set_encap_mode_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_set_encap_mode_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_gpe_set_encap_mode_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_get_encap_mode {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_gpe_get_encap_mode_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_get_encap_mode_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u8 encap_mode;
} vl_api_gpe_get_encap_mode_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_add_del_native_fwd_rpath {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_add;
    u32 table_id;
    u32 nh_sw_if_index;
    u8 is_ip4;
    u8 nh_addr[16];
} vl_api_gpe_add_del_native_fwd_rpath_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_add_del_native_fwd_rpath_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_gpe_add_del_native_fwd_rpath_reply_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_native_fwd_rpaths_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 is_ip4;
} vl_api_gpe_native_fwd_rpaths_get_t;
typedef struct __attribute__ ((packed)) _vl_api_gpe_native_fwd_rpaths_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 count;
    vl_api_gpe_native_fwd_rpath_t entries[0];
} vl_api_gpe_native_fwd_rpaths_get_reply_t;
#define VL_API_GPE_ADD_DEL_FWD_ENTRY_CRC "gpe_add_del_fwd_entry_afbf857a"
#define VL_API_GPE_ADD_DEL_FWD_ENTRY_REPLY_CRC "gpe_add_del_fwd_entry_reply_efe5f176"
#define VL_API_GPE_ENABLE_DISABLE_CRC "gpe_enable_disable_eb0e943b"
#define VL_API_GPE_ENABLE_DISABLE_REPLY_CRC "gpe_enable_disable_reply_e8d4e804"
#define VL_API_GPE_ADD_DEL_IFACE_CRC "gpe_add_del_iface_42d6b533"
#define VL_API_GPE_ADD_DEL_IFACE_REPLY_CRC "gpe_add_del_iface_reply_e8d4e804"
#define VL_API_GPE_FWD_ENTRY_VNIS_GET_CRC "gpe_fwd_entry_vnis_get_51077d14"
#define VL_API_GPE_FWD_ENTRY_VNIS_GET_REPLY_CRC "gpe_fwd_entry_vnis_get_reply_aa70da20"
#define VL_API_GPE_FWD_ENTRIES_GET_CRC "gpe_fwd_entries_get_8d1f2fe9"
#define VL_API_GPE_FWD_ENTRIES_GET_REPLY_CRC "gpe_fwd_entries_get_reply_07b02c34"
#define VL_API_GPE_FWD_ENTRY_PATH_DUMP_CRC "gpe_fwd_entry_path_dump_39bce980"
#define VL_API_GPE_FWD_ENTRY_PATH_DETAILS_CRC "gpe_fwd_entry_path_details_a9bdc1f1"
#define VL_API_GPE_SET_ENCAP_MODE_CRC "gpe_set_encap_mode_f3f93ce9"
#define VL_API_GPE_SET_ENCAP_MODE_REPLY_CRC "gpe_set_encap_mode_reply_e8d4e804"
#define VL_API_GPE_GET_ENCAP_MODE_CRC "gpe_get_encap_mode_51077d14"
#define VL_API_GPE_GET_ENCAP_MODE_REPLY_CRC "gpe_get_encap_mode_reply_36e3f7ca"
#define VL_API_GPE_ADD_DEL_NATIVE_FWD_RPATH_CRC "gpe_add_del_native_fwd_rpath_bfc42b8f"
#define VL_API_GPE_ADD_DEL_NATIVE_FWD_RPATH_REPLY_CRC "gpe_add_del_native_fwd_rpath_reply_e8d4e804"
#define VL_API_GPE_NATIVE_FWD_RPATHS_GET_CRC "gpe_native_fwd_rpaths_get_c5e0d91b"
#define VL_API_GPE_NATIVE_FWD_RPATHS_GET_REPLY_CRC "gpe_native_fwd_rpaths_get_reply_1e4536e3"

#endif
